/* ---------------------------------------------------------- */
/*  pako_test.cpp                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - appmain class
    @author   rerofumi
    @since    Nov.04.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006,2011 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
-------------------------------------------------------
update
  Apr.09.2011 - Xe[g}VʂƂȂWIAppƂċLq
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include <math.h>

#include "app_laster_shoot.h"
#include "ls_state_top.h"

#include "bootmain.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoLasterShoot::PakoLasterShoot()
	: m_bDevelopDisp(false)
	, m_bFramerateDisp(false)
{
}

/**
 * fXgN^(n)
 */
PakoLasterShoot::~PakoLasterShoot()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/**
 * SDL_mixer gp鉹gƃ`Nobt@TCYw肷
 *
 * @param freq [in] gA{ 44100  0.5{]
 * @param bufsize [in] chunkTCYA1024 ǂłɏグ
 */
void PakoLasterShoot::setSoundQuality(int freq, int bufsize)
{
	m_iSoundParamFreq = freq;
	m_iSoundParamBuff = bufsize;
}

/*------------------------------------------------------*/
/* private method                                       */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- onBoot() */
int PakoLasterShoot::onBoot(void)
{
    setScreenSize(SCREEN_WIDTH, SCREEN_HEIGHT);
    setFrameSkipMode(PAKO_FRAME_SKIP_NONE);

    return PakoOpenglApp::onBoot();
}


/* ----------------------------------------- */
/* --- onExecuteBefore() */
/**
 * s̏
 *
 * @return 0ŐIAȊOňُI
 *
 */
int PakoLasterShoot::onExecuteBefore(void)
{
    /* - eNX`̓ǂݍ */
    readTexture(0, "texture/game_object.png");
    readTexture(1, "texture/title.png");

    /* - CQ[Xe[g}V̐ */
    m_pStateMachine = new PstmTop(this, LS_STATE_TOP_NAME);
    m_pStateMachine->doReset();

    return(0);
}


/* ----------------------------------------- */
/* --- onExecuteAfter() */
/**
 * sǏЕt
 *
 * @return 0ŐIAȊOňُI
 *
 */
int PakoLasterShoot::onExecuteAfter(void)
{
    delete m_pStateMachine;

    return(0);
}


/* ----------------------------------------- */
/* --- tick() */
/**
 * t[ĂяoQ[{̃\bh
 * pŃI[o[ChĂɃQ[{̂Lq
 * 1t[̍ƂI烁\bh𔲂邱
 *
 * @return trueŒʏƒAfalseŃQ[I
 *
 */
bool PakoLasterShoot::tick(void)
{
    m_pStateMachine->tick();

    return !m_pStateMachine->isDone();
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
 * t[Ăяoʕ\\bh
 * pŃI[o[ChĂɉʕ`揈Lq
 * tick()̒ɋLqĂǂA̓t[XLbv
 * ΂Ă΂Ȃ̂ŏ肭p
 *
 * @return trueŒʏƒAfalseŕ\ُ
 *
 */
bool PakoLasterShoot::tickDisplay(void)
{
    float view_x, view_y;

    /* -- ʃNA */
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glDepthMask(GL_TRUE);
    glEnable(GL_DEPTH_TEST);
    /* -- world ݒ */
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (m_WindowSizeW > m_WindowSizeH) {
        view_x = tan(3.1415926353f / 2.0f * (60.0f / 180.0f));
        view_y = tan(3.1415926353f / 2.0f *
            (((60.0f / 180.0f) * m_WindowSizeH) / m_WindowSizeW));
    }
    else {
        view_y = tan(3.1415926353f / 2.0f * (60.0f / 180.0f));
        view_x = tan(3.1415926353f / 2.0f *
            (((60.0f / 180.0f) * m_WindowSizeW) / m_WindowSizeH));
    }
    glFrustum(-view_x/2, view_x/2, -view_y/2, view_y/2, 0.5, 1024.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glCullFace( GL_BACK );
    glFrontFace( GL_CCW );
    glEnable( GL_CULL_FACE );

    /* --- ʕ`揈 */
    m_pStateMachine->tickDisplay();

	/* -- XvCg\ */
    displaySprite();

    return true;
}
