/**
 *  --- PAKO SDL game system boot main.
 *
 */
#include "bootmain.h"
#include "app_laster_shoot.h"

PakoLasterShoot *app;

/* --------------------------------------------- */
/* --- C[`                        --- */
/* --------------------------------------------- */
#ifdef __cplusplus
extern "C" int  main(int argc, char *argv[])
#else
int  main(int argc, char *argv[])
#endif	//__cplusplus
{
	bool sw_fullscreen = false;
	bool sw_disp_dist = false;
	bool sw_disp_load = false;
	int  sw_sound_freq = 44100;
	int  sw_sound_buff = 1024;

	/* --- R}hC */
	for(int i=1; i<argc; i++) {
		std::string line;
		line = argv[i];
		/* - tXN[[h */
		if ((line.find("--fullscreen") == 0) || (line.find("-F") == 0)){
			sw_fullscreen = true;
		}
		/* - }bv\[h */
		if ((line.find("--disp=distance") == 0) || (line.find("-D") == 0)){
			sw_disp_dist = true;
		}
		/* - ԕ\[h */
		if ((line.find("--disp=load") == 0) || (line.find("-L") == 0)){
			sw_disp_load = true;
		}
		/* - TEhg */
		if (line.find("--sound-freq=") == 0) {
			int length = line.size();
			int eq = line.find("=");
			int numsize = length-eq-1;
			if (numsize > 0) {
				std::string freq = line.substr(eq+1, numsize);
				try {
					sw_sound_freq = strtol(freq.c_str(), NULL, 10);
				}
				catch(...) {
					sw_sound_freq = 44100;
				}
			}
		}
		/* - TEh`Nobt@ */
		if (line.find("--sound-buffer=") == 0) {
			int length = line.size();
			int eq = line.find("=");
			int numsize = length-eq-1;
			if (numsize > 0) {
				std::string freq = line.substr(eq+1, numsize);
				try {
					sw_sound_buff = strtol(freq.c_str(), NULL, 10);
				}
				catch(...) {
					sw_sound_buff = 1024;
				}
			}
			if (sw_sound_buff < 64) {
				sw_sound_buff = 64;
			}
		}
	}

	/* --- AvP[VNX */
	app = new PakoLasterShoot;
	app->setFullScreen(sw_fullscreen);
	app->setDevelopDisp(sw_disp_dist);
	app->setFramerateDisp(sw_disp_load);
	app->setSoundQuality(sw_sound_freq, sw_sound_buff);
	app->setWindowTitle(WindowName);
	if (app == 0) {
		exit(-1);
	}

	/* --- s */
	app->execute();

	/* --- I */
	delete app;

	return(0);
}

