/* ---------------------------------------------------------- */
/*  bulletbase.cpp                                            */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		eƂ̔łIuWFNgNX
@author		K.Kunikane (rerofumi)
@since		Feb.15.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "bulletbase.h"
#include "pako/pako_simple_app.h"
#include "bootmain.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
BulletBase::BulletBase(PakoSpriteItem *SpriteInstance)
	: ShootingObject( SpriteInstance )
{
	/* ---  */
	m_EnemyObject = NULL;
	m_Direction = 0.0;
	m_DirectionAdd = 0.0;
	m_Speed = 1.0;
	m_SpeedR = 0.0;
	m_Accelerator = 0.0;
	m_Accelerator = 0.0;
	m_Limit = 0.0;
	m_LimitR = 0.0;
	m_AddRoll = 0.0;
	m_Timer = 0;
	m_LifeTime = 0;
	m_ListPrev = NULL;
	m_ListNext = NULL;
}


/**
* fXgN^(n)
*/
BulletBase::~BulletBase()
{
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- tick() */
/**
* IuWFNg1t[ړ
*
* @return true ȂIuWFNgAfalse ŏI
*
*/
bool BulletBase::tick()
{
	bool  alive;
	float  dx, dy;

	alive = true;

	/* ---  */
	/* - isx */
	if (m_Speed < m_Limit) {
		m_Speed += m_Accelerator;
		if (m_Speed < 0) {
			m_Speed = 0;
		}
	}
	/* - isω */
	m_SpeedR += m_AcceleratorR;
	if (m_DirectionAdd >= 0) {
		if (m_DirectionAdd < m_LimitR) {
			m_DirectionAdd += m_SpeedR;
		}
	}
	else {
		if (m_DirectionAdd > m_LimitR) {
			m_DirectionAdd += m_SpeedR;
		}
	}
	/* - LN^[] */
	m_pSprite->m_RollZ = m_pSprite->m_RollZ + m_AddRoll;
	m_pSprite->m_RollZ = m_pSprite->m_RollZ - floor(m_pSprite->m_RollZ / 360.0f) * 360.0f;

	/* --- is1ړ */
	dx = cos(m_Direction + m_DirectionAdd);
	dy = sin(m_Direction + m_DirectionAdd);
	dx *= m_Speed;
	dy *= m_Speed;
	m_pSprite->m_PosX += dx;
	m_pSprite->m_PosY += dy;

	/* --- \̈͂ݏo`FbN */
	if ((m_pSprite->m_PosX + (m_pSprite->m_SizeW / 2.0)) <= 0) {
		alive = false;
	}
	if ((m_pSprite->m_PosX - (m_pSprite->m_SizeW / 2.0)) >= SCREEN_WIDTH) {
		alive = false;
	}
	if ((m_pSprite->m_PosY + (m_pSprite->m_SizeH / 2.0)) <= 0) {
		alive = false;
	}
	if ((m_pSprite->m_PosY - (m_pSprite->m_SizeH / 2.0)) >= SCREEN_HEIGHT) {
		alive = false;
	}

	/* --- JE^[ */
	if (m_LifeTime > 0) {
		m_LifeTime -= 1;
	}
	else {
		m_LifeTime = 0;
		alive = false;
	}

	/* --- ܂ */
	return(alive);
}



/* ----------------------------------------- */
/* --- tickDisplay() */
/**
* IuWFNg1t[\
* ݊p
* @return true ȂIuWFNgAfalse ŏI
*
*/
bool BulletBase::tickDisplay()
{
	return true;
}

/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

