/* ---------------------------------------------------------- */
/*  bulletmaker.cpp                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		e̐ƊǗA@pƓGp̃Cve[V
    @author		K.Kunikane (rerofumi)
    @since		Apr.16.2011
*/
/*-----------------------------------------------------
Copyright (C) 2011 rerofumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "bulletmaker.h"
#include "ls_game_manager.h"
#include "enemymanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* mybullet                                             */
/*------------------------------------------------------*/

void MyBulletMaker::Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum)
{
	BulletManage::Init();

	m_pApp = pApp;
	m_nSpriteLayer = nSpriteLayer;
	m_nSpriteSize = nSpriteNum;
}


int MyBulletMaker::CheckHit(EnemyManage* enemys)
{
	int score = 0;
	int total = 0;
	BulletBase  *obj, *next;

	/* --- eXgɐςłIuWFNgS */
	obj = (BulletBase*)m_ListHead;
	while(obj != 0) {
		next = (BulletBase*)obj->m_ListNext;
		/* - 蔻肪eΏ */
		if (obj->m_bHitEnable) {
			/* 蔻 */ 
			score = enemys->CheckHit(obj);
			total += score;
			if (score) {
				delete_bullet(obj);
			}
		}
		/* -  */
		obj = next;
	}

	return(total);
}


void MyBulletMaker::doShot(int level, float pos_x, float pos_y)
{
	switch(level)
	{
	case 1:
		request_level1(pos_x, pos_y);
		break;
	case 2:
		request_level2(pos_x, pos_y);
		break;
	case 3:
		request_level3(pos_x, pos_y);
		break;
	default:
		request_level1(pos_x, pos_y);
		break;
	}
}

void MyBulletMaker::request_level1(float x, float y)
{
	PakoSpriteItem *obj;
	BulletBase *shot;
	int spindex;

	/* --- P */
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 90.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
		/* - SE */
		m_pApp->getSound()->SE(SE_SHOT);
	}
}

void MyBulletMaker::request_level2(float x, float y)
{
	PakoSpriteItem *obj;
	BulletBase *shot;
	int spindex;

	/* --- Q */
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 90.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x - 16.0f;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
	}
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 90.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x + 16.0f;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
		/* - SE */
		m_pApp->getSound()->SE(SE_SHOT);
	}
}

void MyBulletMaker::request_level3(float x, float y)
{
	PakoSpriteItem *obj;
	BulletBase *shot;
	int spindex;

	/* --- 3way */
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 90.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
	}
	/* --- 3way */
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 105.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
	}
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = true;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 8;
		shot->m_fHitRectH = 10;
		shot->m_Direction = (360.0f - 75.0f) * 3.1415926f * 2 / 360.0f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 8.0f;
		obj->m_PosX = x;
		obj->m_PosY = y;
		obj->m_SizeW = 32;
		obj->m_SizeH = 48;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 992;
		obj->m_TexV = 88;
		obj->m_TexW = 32;
		obj->m_TexH = 48;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
		/* - SE */
		m_pApp->getSound()->SE(SE_SHOT);
	}
}



/*------------------------------------------------------*/
/* powerup item                                         */
/*------------------------------------------------------*/

void ItemMaker::Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum)
{
	BulletManage::Init();

	m_pApp = pApp;
	m_nSpriteLayer = nSpriteLayer;
	m_nSpriteSize = nSpriteNum;
}


void ItemMaker::doShot(float pos_x, float pos_y)
{
	PakoSpriteItem *obj;
	BulletBase *shot;
	int spindex;

	/* --- ACeo */
	obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
  	if (obj) {
		shot = new BulletBase(obj);
		shot->m_bGrazeEnable = false;
		shot->m_bHitEnable = true;
		shot->m_bSquareHit = false;
		shot->SetHitSize(12.0f);
		shot->m_fHitRectW = 14;
		shot->m_fHitRectH = 14;
		shot->m_Direction = (360.0f - 270.0f) * 3.1415926f * 2 / 360.f;
		shot->m_LifeTime = 65535;
		shot->m_Limit = 255.0f;
		shot->m_Speed = 3.0f;
		obj->m_PosX = pos_x;
		obj->m_PosY = pos_y;
		obj->m_SizeW = 62;
		obj->m_SizeH = 68;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 928;
		obj->m_TexV = 96;
		obj->m_TexW = 62;
		obj->m_TexH = 68;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = true;
		obj->m_Working = true;
		obj->m_Visible = true;
		obj->m_TextureID = 0;
		AddBullet(shot);
	}
}


/*------------------------------------------------------*/
/* enemybullet                                          */
/*------------------------------------------------------*/

void EnemyBulletMaker::Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum)
{
	BulletManage::Init();

	m_pApp = pApp;
	m_nSpriteLayer = nSpriteLayer;
	m_nSpriteSize = nSpriteNum;
}


void EnemyBulletMaker::doShot(int num, float aim, float fin, float speed, float pos_x, float pos_y)
{
	PakoSpriteItem *obj;
	BulletBase *shot;
	int spindex;
	float aim_r = aim - (fin * 0.5f);
	float dr = 0.0f;
	if (num > 2) {
		dr = fin / (num - 1);
	}

	/* --- Ge */
	for(int i=0; i<num; i++) {
		obj = m_pApp->getReserveSprite(m_nSpriteLayer, &spindex);
		if (obj) {
			shot = new BulletBase(obj);
			shot->m_bGrazeEnable = false;
			shot->m_bHitEnable = true;
			shot->m_bSquareHit = false;
			shot->SetHitSize(2.0f);
			shot->m_fHitRectW = 4;
			shot->m_fHitRectH = 4;
			shot->m_Direction = (360.0f - aim_r) * 3.1415926f * 2 / 360.f;
			shot->m_LifeTime = 65535;
			shot->m_Limit = 255.0f;
			shot->m_Speed = speed;
			obj->m_PosX = pos_x;
			obj->m_PosY = pos_y;
			obj->m_SizeW = 64;
			obj->m_SizeH = 64;
			obj->m_Blend = 1.0f;
			obj->m_TexU = 864;
			obj->m_TexV = 704;
			obj->m_TexW = 64;
			obj->m_TexH = 64;
			obj->m_RollZ = 0.0f;
			obj->m_Zoom = 1.0f;
			obj->m_PosCenter = true;
			obj->m_Working = true;
			obj->m_Visible = true;
			obj->m_TextureID = 0;
			AddBullet(shot);
		}
		aim_r += dr;
	}
}
