/* ---------------------------------------------------------- */
/*  bulletmanage.cpp                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		eʂ̊ǗNX
@author		K.Kunikane (rerofumi)
@since		Feb.17.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "bulletmanage.h"

#include "ls_game_manager.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
BulletManage::BulletManage()
{
	/* ---  */
	m_BulletNum = 0;
	m_ListHead = 0;
	m_ListTail = 0;
}


/**
* fXgN^(n)
*/
BulletManage::~BulletManage()
{
	BulletBase*  obj;
	BulletBase*  next;

	/* --- eXgɐςłIuWFNgSĉ */
	obj = (BulletBase*)m_ListHead;
	try {
		while(obj != 0) {
			next = (BulletBase*)obj->m_ListNext;
			delete obj;
			obj = next;
		}
	}
	catch(...) {
	}
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- Init() */
/**
* (Q[I[o[Ƃ)
*
* @return 
*
*/
void  BulletManage::Init()
{
	BulletBase  *obj, *next;

	/* --- eXgɐςłIuWFNgSĉ */
	obj = (BulletBase*)m_ListHead;
	try {
		while(obj != 0) {
			next = (BulletBase*)obj->m_ListNext;
			delete obj;
			obj = next;
		}
	}
	catch(...) {
	}
	/* --- oNA */
	m_BulletNum = 0;
	m_ListHead = 0;
	m_ListTail = 0;
}


/* ----------------------------------------- */
/* --- Tick() */
/**
* SẴIuWFNg 1t[ړ
*
* @return true ŒʏIAfalse ̎̓IuWFNg
*
*/
bool  BulletManage::tick()
{
	BulletBase  *obj, *next;
	bool result;

	/* --- IuWFNgۂł */
	if (m_BulletNum == 0) {
		return(false);
	}

	/* --- eXgɐςłIuWFNgS */
	obj = (BulletBase*)m_ListHead;
	try {
		while(obj != 0) {
			next = (BulletBase*)obj->m_ListNext;
			result = obj->tick();
			if (result == false) {
				/* sIuWFNgj */
				delete_bullet(obj);
			}
			/* -  */
			obj = next;
		}
	}
	catch(...) {
	}

	return(true);
}


/* ----------------------------------------- */
/* --- Display() */
/**
* SẴIuWFNg\
*
*/
bool BulletManage::tickDisplay()
{
	BulletBase  *obj, *next;
	int n;

	/* --- \̓obt@̍ő吔܂łł */
	obj = (BulletBase*)m_ListHead;
	n = 0;
	while(obj != 0) {
		next = (BulletBase*)obj->m_ListNext;
		obj->tickDisplay();
		/* -  */
		obj = next;
		n += 1;
	}


	return(true);
}


/* ----------------------------------------- */
/* --- AddBullet() */
/**
* IuWFNgXgɒǉ
*
* @return ۂɍƂIuWFNg
*
*/
bool  BulletManage::AddBullet(void* obj)
{
	BulletBase *mobj, *tail;
	bool  result;

	mobj = (BulletBase*)obj;
	result = true;
	/* --- obt@̐葽Ȃ肻ς܂Ȃ */
	if (m_BulletNum < BS_SPNUM_BULLET) {
		if (m_ListHead == 0) {
			/* - ŏ̈ꔭڂ͐擪ɂL^ */
			m_ListHead = (void*)obj;
		}
		/* - XgŌɒǉ */
		mobj->m_ListPrev = m_ListTail;
		mobj->m_ListNext = 0;
		if (m_ListTail) {
			tail = (BulletBase*)m_ListTail;
			tail->m_ListNext = (void*)mobj;
		}
		m_ListTail = (void*)mobj;
		m_BulletNum += 1;
	}
	else {
		result = false;
	}

	return(result);
}


/* ----------------------------------------- */
/* --- CheckHit() */
/**
* @ƒeƂ̃qbg()
*
* @return @ɒeĂƂ true, ȊO false
*
*/
bool  BulletManage::CheckHit(ShootingObject* ship)
{
	BulletBase  *obj, *next;
	bool  result;

	result = false;
	/* --- 蔻̃NA */
	m_Graze = 0;
	/* --- eXgɐςłIuWFNgS */
	obj = (BulletBase*)m_ListHead;
	try {
		while(obj != 0) {
			next = (BulletBase*)obj->m_ListNext;
			/* - 蔻肪eΏ */
			if (obj->m_bHitEnable) {
				/* 蔻 */
				if (obj->CheckCollision(ship)) {
					result = true;
				}
				/* 蔻 */
				else if (obj->CheckGraze(ship)) {
					m_Graze += 1;
					/* e͓xƔfȂ悤 */
					obj->m_bGrazeEnable = false;
				}
			}
			/* -  */
			obj = next;
		}
	}
	catch(...) {
	}

	return(result);
}


/* ----------------------------------------- */
/* --- GetGraze() */
/**
* 蔻̌ʂn
*
* @return 蓾_
*
*/
int  BulletManage::GetGraze()
{
	return(m_Graze);
}


/* ----------------------------------------- */
/* --- DisableAllBullet() */
/**
* ݉ʏɎcĂẽ{[iXNA
*
* @return ce{[iX
*
*/
int  BulletManage::DisableAllBullet()
{
	BulletBase  *obj, *next;
	int  score;

	score = 0;
	/* --- eXgɐςłIuWFNgS */
	obj = (BulletBase*)m_ListHead;
	try {
		while(obj != NULL) {
			next = static_cast<BulletBase*>(obj->m_ListNext);
			/* - 蔻肪eΏ */
			if (obj->m_bHitEnable) {
				obj->m_bHitEnable = false;
				obj->m_LifeTime = 5;
				obj->m_pSprite->m_Blend = 0.3f;
				score += 100;
			}
			/* -  */
			obj = next;
		}
	}
	catch(...) {
	}

	return(score);
}


/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

void  BulletManage::delete_bullet(void *obj)
{
	BulletBase *mobj, *prevobj, *nextobj;

	mobj = (BulletBase*)obj;

	/* --- Xg؂藣 */
	if (m_ListHead == mobj) {
		m_ListHead = mobj->m_ListNext;
	}
	if (m_ListTail == mobj) {
		m_ListTail = mobj->m_ListPrev;
	}
	prevobj = (BulletBase*)mobj->m_ListPrev;
	nextobj = (BulletBase*)mobj->m_ListNext;
	if (prevobj) {
		prevobj->m_ListNext = mobj->m_ListNext;
	}
	if (nextobj) {
		nextobj->m_ListPrev = mobj->m_ListPrev;
	}
	/* --- IuWFNg̃[X */
	delete mobj;
	m_BulletNum -= 1;
}


void*  BulletManage::get_next_bullet(void* obj)
{
	BulletBase *mobj;

	mobj = (BulletBase*)obj;
	/* --- KvȂ̂̃\bhH */
	return((void*)mobj->m_ListNext);
}


