/* ---------------------------------------------------------- */
/*  bulletmaker.h                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		GIuWFNg̐ƃCt^CǗ
    @author		K.Kunikane (rerofumi)
    @since		Apr.17.2011
*/
/*-----------------------------------------------------
 Copyright (C) 2011 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "enemymanage.h"
#include "ls_game_manager.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

EnemyManage::EnemyManage(void)
{
}

EnemyManage::~EnemyManage(void)
{
}


void  EnemyManage::Init(PakoOpenglApp* pApp, EnemyBulletMaker *pBulletMaker, MyShipManage *pMyship, int enemy_splayer, int wall_splayer)
{
	m_pApp = pApp;
	m_pBulletMaker = pBulletMaker;
	m_pMyShip = pMyship;
	m_iSpliteLayerEnemy = enemy_splayer;
	m_iSpliteLayerWall = wall_splayer;
	m_vObject.clear();
	m_vNewObject.clear();
}


void  EnemyManage::AddEnemy(int chara, float x, float y)
{
    PakoSpriteItem *obj;
	EnemyObject *enemy;
	int spindex;

	obj = m_pApp->getReserveSprite(m_iSpliteLayerEnemy, &spindex);
	if (obj == 0) {
		return;
	}

	enemy = new EnemyObject(obj);
	enemy->Init(chara, m_pBulletMaker, m_pMyShip, this);
    obj->m_PosX = x;
    obj->m_PosY = y;
    obj->m_Blend = 1.0f;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
	obj->m_Flash = false;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
	obj->m_Working = true;
    obj->m_TextureID = 0;
	enemy->m_fOrgX = x;
	enemy->m_fOrgY = y;
	enemy->m_bHitEnable = true;
	enemy->m_bSquareHit = true;
	switch(chara) {
	case ENEMY_ZAKO1:
	case ENEMY_ZAKO2:
	case ENEMY_ZAKO3:
	case ENEMY_ZAKO4:
	case ENEMY_ZAKO5:
	case ENEMY_ZAKO6:
		obj->m_PosY -= 32.0f;
		obj->m_SizeW = 72;
		obj->m_SizeH = 64;
		obj->m_TexU = 780;
		obj->m_TexV = 704;
		obj->m_TexW = 72;
		obj->m_TexH = 64;
		enemy->SetHitSize(50, 50);
		enemy->m_HitPoint = 1;
		enemy->SetScore(100);
		break;
	case ENEMY_CHUU1:
	case ENEMY_CHUU2:
		obj->m_PosY -= 40.0f;
		obj->m_SizeW = 112;
		obj->m_SizeH = 80;
		obj->m_TexU = 660;
		obj->m_TexV = 704;
		obj->m_TexW = 112;
		obj->m_TexH = 80;
		enemy->SetHitSize(96, 60);
		enemy->m_HitPoint = 24;
		enemy->SetScore(1000);
		break;
	case ENEMY_BOSS1:
		obj->m_PosY -= 100.0f;
		obj->m_SizeW = 312;
		obj->m_SizeH = 208;
		obj->m_TexU = 644;
		obj->m_TexV = 480;
		obj->m_TexW = 312;
		obj->m_TexH = 208;
		enemy->SetHitSize(300, 180);
		enemy->m_HitPoint = 120;
		enemy->SetScore(10000);
		break;
	case ENEMY_BOSS2:
		obj->m_PosY -= 100.0f;
		obj->m_SizeW = 312;
		obj->m_SizeH = 208;
		obj->m_TexU = 644;
		obj->m_TexV = 480;
		obj->m_TexW = 312;
		obj->m_TexH = 208;
		enemy->SetHitSize(300, 180);
		enemy->m_HitPoint = 180;
		enemy->SetScore(20000);
		break;
	}
	m_vNewObject.push_back(enemy);
}

void  EnemyManage::AddWall(int chara, float x, float y)
{
    PakoSpriteItem *obj;
	EnemyObject *enemy;
	int spindex;

	obj = m_pApp->getReserveSprite(m_iSpliteLayerWall, &spindex);
	if (obj == 0) {
		return;
	}

	enemy = new EnemyObject(obj);
	enemy->Init(chara, m_pBulletMaker, m_pMyShip, this);
    obj->m_PosX = x;
    obj->m_PosY = y;
    obj->m_Blend = 1.0f;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
	obj->m_Flash = false;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
	obj->m_Working = true;
    obj->m_TextureID = 0;
	enemy->m_bHitEnable = true;
	enemy->m_bSquareHit = true;
	if (chara == ENEMY_WALL1) {
		obj->m_PosY -= 68.0f;
		obj->m_SizeW = 180;
		obj->m_SizeH = 136;
		obj->m_TexU = 736;
		obj->m_TexV = 0;
		obj->m_TexW = 180;
		obj->m_TexH = 136;
		enemy->SetHitSize(190, 156);
	}
	else {
		obj->m_PosY -= 240.0f;
		obj->m_SizeW = 80;
		obj->m_SizeH = 480;
		obj->m_TexU = 640;
		obj->m_TexV = 0;
		obj->m_TexW = 80;
		obj->m_TexH = 480;
		enemy->SetHitSize(90, 500);
	}
	m_vNewObject.push_back(enemy);
}

int  EnemyManage::CheckHit(ShootingObject* myshot)
{
	int result = 0;
	std::vector<EnemyObject*>::iterator it;
	EnemyObject *ptr;

	for(it=m_vObject.begin(); it!=m_vObject.end(); it++) {
		ptr = *it;
		if ((ptr->m_Charactor == ENEMY_WALL1) ||
			(ptr->m_Charactor == ENEMY_WALL2)) {
			continue;
		}
		if (ptr->CheckCollision(myshot)) {
			if (ptr->m_HitPoint > 0) {
				ptr->m_HitPoint -= 1;
				if (ptr->m_HitPoint == 0) {
					if ((ptr->m_Charactor == ENEMY_BOSS1) ||
						(ptr->m_Charactor == ENEMY_BOSS2)) {
						m_pApp->getSound()->SE(SE_BOSS_EXPLOSE);
					}
					else {
						m_pApp->getSound()->SE(SE_HIT);
					}
					ptr->Hit();
					result += ptr->GetScore();
				}
				else {
					ptr->m_pSprite->m_Flash = true;
					m_pApp->getSound()->SE(SE_BOSS_HIT);
					result += 10;
				}
			}
		}
	}

	return result;
}

bool  EnemyManage::CheckMyshipHit(ShootingObject* myship)
{
	bool result = false;
	std::vector<EnemyObject*>::iterator it;
	EnemyObject *ptr;

	for(it=m_vObject.begin(); it!=m_vObject.end(); it++) {
		ptr = *it;
		if (ptr->CheckCollision(myship)) {
			result = true;
		}
	}

	return result;
}

bool EnemyManage::isDestroyBoss(void)
{
	return m_bDestroyBoss;
}

bool EnemyManage::isAliveBoss(void)
{
	return m_bAliveBoss;
}


/* --------------------------- */
/* --- work                    */
/* --------------------------- */

bool  EnemyManage::tick()
{
	std::vector<EnemyObject*>::iterator it;
	EnemyObject *ptr;
	m_bAliveBoss = false;
	m_bDestroyBoss = false;

	for(it=m_vObject.begin(); it!=m_vObject.end();) {
		bool del = false;
		ptr = *it;
		ptr->m_pSprite->m_Flash = false;
		if ((ptr->m_Charactor == ENEMY_BOSS1) ||
			(ptr->m_Charactor == ENEMY_BOSS2)) {
				m_bAliveBoss = true;
		}

		if (ptr->tick() == false) {
			del = true;
			if ((ptr->m_Charactor == ENEMY_BOSS1) ||
				(ptr->m_Charactor == ENEMY_BOSS2)) {
					m_bDestroyBoss = true;
			}
		}

		// next
		if (del == true) {
			it = m_vObject.erase(it);
			delete ptr;
		}
		else {
			it++;
		}
	}

	// appear new object
	for(it=m_vNewObject.begin(); it!=m_vNewObject.end(); it++) {
		m_vObject.push_back(*it);
	}
	m_vNewObject.clear();

	return true;
}

bool  EnemyManage::tickDisplay()
{
	std::vector<EnemyObject*>::iterator it;
	EnemyObject *ptr;

	for(it=m_vObject.begin(); it!=m_vObject.end(); it++) {
		ptr = *it;
		ptr->tickDisplay();
	}

	return true;
}


