/* ---------------------------------------------------------- */
/*  enemyobject.cpp                                           */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		GN҂̈̂̃IuWFNg
@author		K.Kunikane (rerofumi)
@since		Feb.15.2005
$Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "enemyobject.h"
#include "enemymanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
EnemyObject::EnemyObject(PakoSpriteItem *SpriteInstance)
	: ShootingObject( SpriteInstance )
	, m_IsHit(false)
	, m_HitWait(0)
	, m_Charactor(0)
	, m_Score(0)
	, m_Timer(0)
	, m_pEnemyManage(0)
	, m_pMyShip(0)
	, m_pBulletMaker(0)
{
}


/**
* fXgN^(n)
*/
EnemyObject::~EnemyObject(void)
{
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- Init() */
/**
* ԏ
*
* @return 
*
*/
void EnemyObject::Init(int chara, EnemyBulletMaker *pBulletMaker, MyShipManage *pMyship, EnemyManage *pEnemyManage)
{
	m_Charactor = chara;
	m_pBulletMaker = pBulletMaker;
	m_pMyShip = pMyship;
	m_pEnemyManage = pEnemyManage;
	m_IsHit = false;
	m_HitWait = 0;
	m_Timer = 0;
}


/* ----------------------------------------- */
/* --- Tick() */
/**
* t[Ƃ̍(ؖԂ)
*
* @return true ȂړAfalse Ȃ
*
*/
bool EnemyObject::tick()
{
	bool  result = true;

	switch(m_Charactor) {
	case ENEMY_ZAKO1:
		result = move_zako1();
		break;
	case ENEMY_ZAKO2:
		result = move_zako2();
		break;
	case ENEMY_ZAKO3:
		result = move_zako3();
		break;
	case ENEMY_ZAKO4:
		result = move_zako4();
		break;
	case ENEMY_ZAKO5:
		result = move_zako5();
		break;
	case ENEMY_ZAKO6:
		result = move_zako6();
		break;
	case ENEMY_CHUU1:
		result = move_chuu1();
		break;
	case ENEMY_CHUU2:
		result = move_chuu2();
		break;
	case ENEMY_BOSS1:
		result = move_boss1();
		break;
	case ENEMY_BOSS2:
		result = move_boss2();
		break;
	case ENEMY_WALL1:
		result = move_wall1();
		break;
	case ENEMY_WALL2:
		result = move_wall2();
		break;
	default:
		break;
	}

	return(result);
}

bool EnemyObject::tickDisplay()
{
	return true;
}


/* ----------------------------------------- */
/* --- Hit() */
/**
* eɂ`
*
* @return 
*
*/
void EnemyObject::Hit()
{
	m_IsHit = true;
	m_HitWait = ENEMYHIT_WAIT;
	if ((m_Charactor == ENEMY_BOSS1) || (m_Charactor == ENEMY_BOSS2)) {
		m_HitWait = ENEMYHIT_WAIT_BOSS;
	}
	/* - Ôߓ蔻Ȃ */
	m_bHitEnable = false;
}



/* ----------------------------------------- */
/* --- SetScore() */
/**
* XRAݒ肷
*
* @param score [in] ̃IuWFNg̓_
* @return 
*
*/
void EnemyObject::SetScore(int score)
{
	m_Score = score;
}


/* ----------------------------------------- */
/* --- GetScore() */
/**
* XRAݒ肷
*
* @return 
*
*/
int EnemyObject::GetScore()
{
	return(m_Score);
}




/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

//! URGPArŎ~܂
bool EnemyObject::move_zako1(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	if (m_pSprite->m_PosY < 100.0f) {
		m_fSpeedBase = 6.0f;
		m_Timer = 0;
	}
	else if (m_Timer < 180) {
		m_fSpeedBase -= 0.3f;
		if (m_fSpeedBase < 0.0f) {
			m_fSpeedBase = 0.0f;
		}
		if ((m_Timer % 60) == 30) {
			m_pBulletMaker->doShot(3, 270.0f, 60.0f, 3.0f, m_pSprite->m_PosX, m_pSprite->m_PosY);
		}
	}
	else {
		if (m_fSpeedBase < 6.0f) {
			m_fSpeedBase += 0.3f;
		}
	}
	m_pSprite->m_PosY += m_fSpeedBase;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! URG2Agړ
bool EnemyObject::move_zako2(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 1.6f;
	m_pSprite->m_PosX = m_fOrgX + sin(m_Timer / 20.0f) * 80.0f;

	/* U */
	if ((m_Timer % 30) == 0) {
		m_pBulletMaker->doShot(1, 270.0f, 0.0f, 3.6f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! URG3A]TU炵
bool EnemyObject::move_zako3(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	if (m_pSprite->m_PosY < 100.0f) {
		m_fSpeedBase = 8.0f;
		m_Timer = 0;
	}
	else if (m_Timer < 180) {
		m_pSprite->m_RollZ += 0.06f;
		m_fSpeedBase -= 0.5f;
		if (m_fSpeedBase < 0.0f) {
			m_fSpeedBase = 0.0f;
		}
		if ((m_Timer % 40) == 20) {
			m_pBulletMaker->doShot(7, 270.0f, 120.0f, 4.0f, m_pSprite->m_PosX, m_pSprite->m_PosY);
		}
	}
	else {
		if (m_fSpeedBase < 9.0f) {
			m_fSpeedBase += 0.6f;
		}
		m_pSprite->m_RollZ = 0.0f;
	}
	m_pSprite->m_PosY += m_fSpeedBase;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! URG4Agړ_
bool EnemyObject::move_zako4(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 1.6f;
	m_pSprite->m_PosX = m_fOrgX + sin(m_Timer / 20.0f) * 80.0f;
	m_pSprite->m_RollZ = -cos(m_Timer / 20.0f) * 0.2f;

	/* U */
	if ((m_Timer % 24) == 0) {
		float aiming;
		aiming = atan((m_pMyShip->m_pSprite->m_PosX - m_pSprite->m_PosX) / (m_pMyShip->m_pSprite->m_PosY - m_pSprite->m_PosY));
		aiming = aiming * 360.0f / (2.0f * 3.1415926f); 
		m_pBulletMaker->doShot(1, 270.0f + aiming, 0.0f, 4.8f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! URG5AEˏo
bool EnemyObject::move_zako5(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	{
		float r;
		float t = static_cast<float>(m_Timer);
		if (t > 35.0f) {
			t = 35.0f;
		}
		r = (20.0f - 4.0f * t) * 3.1415926f * 2.0f / 360.0f;
		float dx = cos(r) * 3.0f;
		float dy = -sin(r) * 3.0f;
		m_pSprite->m_PosX += dx;
		m_pSprite->m_PosY += dy;
		m_pSprite->m_RollZ = -((20.0f - 4.0f * t) / 360.0f);
	}

	/* U */
	if ((m_Timer % 50) == 0) {
		float aiming;
		aiming = atan((m_pMyShip->m_pSprite->m_PosX - m_pSprite->m_PosX) / (m_pMyShip->m_pSprite->m_PosY - m_pSprite->m_PosY));
		aiming = aiming * 360.0f / (2.0f * 3.1415926f); 
		m_pBulletMaker->doShot(1, 270.0f + aiming, 0.0f, 4.8f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! URG6Aˏo
bool EnemyObject::move_zako6(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	{
		float r;
		float t = static_cast<float>(m_Timer);
		if (t > 35.0f) {
			t = 35.0f;
		}
		r = (160.0f + 4.0f * t) * 3.1415926f * 2.0f / 360.0f;
		float dx = cos(r) * 3.0f;
		float dy = -sin(r) * 3.0f;
		m_pSprite->m_PosX += dx;
		m_pSprite->m_PosY += dy;
		m_pSprite->m_RollZ = -((160.0f + 4.0f * t) / 360.0f);
	}

	/* U */
	if ((m_Timer % 50) == 20) {
		float aiming;
		aiming = atan((m_pMyShip->m_pSprite->m_PosX - m_pSprite->m_PosX) / (m_pMyShip->m_pSprite->m_PosY - m_pSprite->m_PosY));
		aiming = aiming * 360.0f / (2.0f * 3.1415926f); 
		m_pBulletMaker->doShot(1, 270.0f + aiming, 0.0f, 4.8f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* ͈͊O */
	if (m_pSprite->m_PosY > 500) {
		result = false;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! {XAÎ~
bool EnemyObject::move_chuu1(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 0.7f;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 540) {
		result = false;
	}

	/* U */
	if ((m_Timer % 60) == 0) {
		m_pBulletMaker->doShot(12, 6.0f, 360.0f, 4.0f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! {X2Aӂӂ
bool EnemyObject::move_chuu2(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 0.7f;
	m_pSprite->m_PosX = m_fOrgX + sin(m_Timer / 80.0f) * 80.0f;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 540) {
		result = false;
	}

	/* U */
	if ((m_Timer % 30) == 0) {
		m_pBulletMaker->doShot(11, (m_Timer % 60)*20.0f, 360.0f, 4.0f, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 64;
		m_pSprite->m_SizeH = 64;
		m_pSprite->m_TexU = 864;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 64;
		m_pSprite->m_TexH = 64;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
		}
		else {
			result = false;
		}
	}

	return result;
}

//! {X1A{
bool EnemyObject::move_boss1(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	if (m_pSprite->m_PosY < 120.0f) {
		m_pSprite->m_PosY += 2.0f;
		m_Timer = 0;
	}
	else {
		m_pSprite->m_PosX = m_fOrgX + sin(m_Timer / 160.0f) * 160.0f;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 224;
		m_pSprite->m_SizeH = 104;
		m_pSprite->m_TexU = 640;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 224;
		m_pSprite->m_TexH = 104;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
			if (m_HitWait == ENEMYHIT_WAIT_BOSS_BULLETCLEAR) {
				m_pBulletMaker->DisableAllBullet();
			}
		}
		else {
			result = false;
		}
	}
	/* U */
	else {
		if ((m_Timer % 60) == 10) {
			m_pBulletMaker->doShot(1, 270.0f, 0.0f, 3.0f, m_pSprite->m_PosX, m_pSprite->m_PosY);
		}
		if ((m_Timer % 100) == 45) {
			m_pBulletMaker->doShot(24, 270.0f, 360.0f, 1.0f, m_pSprite->m_PosX, m_pSprite->m_PosY-45.0f);
		}
		if ((m_Timer % 76) == 5) {
			m_pBulletMaker->doShot(5, 270.0f, 120.0f, 2.0f, m_pSprite->m_PosX-120.0f, m_pSprite->m_PosY+45.0f);
			m_pBulletMaker->doShot(5, 270.0f, 120.0f, 2.0f, m_pSprite->m_PosX+120.0f, m_pSprite->m_PosY+45.0f);
		}
	}

	return result;
}

//! {X2Aextra
bool EnemyObject::move_boss2(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	if (m_pSprite->m_PosY < 120.0f) {
		m_pSprite->m_PosY += 2.0f;
		m_Timer = 0;
	}
	else {
		m_pSprite->m_PosX = m_fOrgX + sin(m_Timer / 160.0f) * 160.0f;
	}

	/* - Č */
	if (m_IsHit == true) {
		/* - qbg}[N\ */
		m_pSprite->m_SizeW = 224;
		m_pSprite->m_SizeH = 104;
		m_pSprite->m_TexU = 640;
		m_pSprite->m_TexV = 800;
		m_pSprite->m_TexW = 224;
		m_pSprite->m_TexH = 104;
		/* - ẽt[Y */
		if (m_HitWait > 0) {
			m_HitWait -= 1;
			if (m_HitWait == ENEMYHIT_WAIT_BOSS_BULLETCLEAR) {
				m_pBulletMaker->DisableAllBullet();
			}
		}
		else {
			result = false;
		}
	}
	/* - U */
	else {
		// URi
		if ((m_Timer % 600) > 400) {
			int localt = (m_Timer % 200);
			if ((localt % 40) == 1) {
				int h = localt / 20;
				m_pEnemyManage->AddEnemy(ENEMY_ZAKO5, m_pSprite->m_PosX + 120.0f, m_pSprite->m_PosY + 80.0f - (h * 16));
				m_pEnemyManage->AddEnemy(ENEMY_ZAKO6, m_pSprite->m_PosX - 120.0f, m_pSprite->m_PosY + 80.0f - (h * 16));
			}
		}
		// ˂
		if ((m_Timer % 600) < 300) {
			if ((m_Timer % 200) < 100) {
				if ((m_Timer % 10) == 1) {
					float dr = sin(static_cast<float>(m_Timer % 100) / 16.0f) * 30.0f;
					m_pBulletMaker->doShot(3, 240.0f+dr, 100.0f, 3.0f, m_pSprite->m_PosX-130.0f, m_pSprite->m_PosY+80.0f);
					m_pBulletMaker->doShot(3, 300.0f-dr, 100.0f, 3.0f, m_pSprite->m_PosX+130.0f, m_pSprite->m_PosY+80.0f);
				}
			}
		}
		// ΂܂
		if ((m_Timer % 120) == 40) {
			m_pBulletMaker->doShot(18, 270.0f, 350.0f, 1.8f, m_pSprite->m_PosX, m_pSprite->m_PosY-40.0f);
		}
		if ((m_Timer % 250) == 140) {
			m_pBulletMaker->doShot(14, 270.0f, 360.0f, 2.6f, m_pSprite->m_PosX, m_pSprite->m_PosY-40.0f);
		}
		// 炩
		if ((m_Timer % 80) == 20) {
			m_pBulletMaker->doShot(1, 260.0f, 0.0f, 1.0f, m_pSprite->m_PosX-100.0f, m_pSprite->m_PosY-30.0f);
			m_pBulletMaker->doShot(1, 280.0f, 0.0f, 1.0f, m_pSprite->m_PosX+100.0f, m_pSprite->m_PosY-30.0f);
		}
	}


	return result;
}

//! 
bool EnemyObject::move_wall1(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 0.7f;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 960) {
		result = false;
	}

	return result;
}

//! 
bool EnemyObject::move_wall2(void)
{
	bool result = true;

	m_Timer += 1;

	/* - ړ */
	m_pSprite->m_PosY += 0.7f;

	/* ͈͊O */
	if (m_pSprite->m_PosY > 960) {
		result = false;
	}

	return result;
}
