/* ---------------------------------------------------------- */
/*  enemyobject.h                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		G̃IuWFNg
@author		K.Kunikane (rerofumi)
@since		Feb.15.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

#ifndef ENEMYOBJECT_H
#define ENEMYOBJECT_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "bulletmaker.h"
#include "myshipmanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

static const int ENEMYHIT_WAIT = 8;
static const int ENEMYHIT_WAIT_BOSS = 30;
static const int ENEMYHIT_WAIT_BOSS_BULLETCLEAR = 20;

enum ENEMYSPEC {
	ENEMY_ZAKO1 = 1,
	ENEMY_ZAKO2,
	ENEMY_ZAKO3,
	ENEMY_ZAKO4,
	ENEMY_ZAKO5,
	ENEMY_ZAKO6,
	ENEMY_CHUU1,
	ENEMY_CHUU2,
	ENEMY_BOSS1,
	ENEMY_BOSS2,
	ENEMY_WALL1,
	ENEMY_WALL2
};

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/
class EnemyManage;

/**
* @brief GN҂̕\NX
*
* @todo -
* @bug -
*/
class EnemyObject : public ShootingObject
{
	/* ----------------------------------- */
	/* --- RXgN^EfXgN^ */
public:
	EnemyObject(PakoSpriteItem *SpriteInstance);
	virtual  ~EnemyObject(void);

	/* ----------------------------------- */
	/* --- pubNo */
public:
	//! Gɂꂿ(qbg}[N\)
	bool  m_IsHit;
	//! \LN^[
	int  m_Charactor;
	//! ̗
	int  m_HitPoint;
	//! õ|WV
	float m_fOrgX, m_fOrgY;

	/* ----------------------------------- */
	/* --- vCx[go */
private:
	//! qbg}[N\EFCg
	int  m_HitWait;
	//! ̃IuWFNg̓_
	int  m_Score;
	//! ANVp^C}[
	int  m_Timer;
	//! Xs[h
	float m_fSpeedBase;

	//! eCX^X
	EnemyBulletMaker *m_pBulletMaker;
	//! @CX^X(_ep)
	MyShipManage *m_pMyShip;
	//! eAGNX
	EnemyManage *m_pEnemyManage;

	/* ----------------------------------- */
	/* --- pubN\bh */
public:
	void Init(int chara, EnemyBulletMaker *pBulletMaker, MyShipManage *pMyship, EnemyManage *pEnemyManage);
	bool tick();
	bool tickDisplay();
	void Hit();
	bool isHit(void) { return m_IsHit; };
	void SetScore(int score);
	int GetScore();

	/* ----------------------------------- */
	/* --- vCx[g\bh */
	bool move_zako1(void);
	bool move_zako2(void);
	bool move_zako3(void);
	bool move_zako4(void);
	bool move_zako5(void);
	bool move_zako6(void);
	bool move_chuu1(void);
	bool move_chuu2(void);
	bool move_boss1(void);
	bool move_boss2(void);
	bool move_wall1(void);
	bool move_wall2(void);
private:

};


#endif

