/**
 * PAKO state machine
 * Q[Xe[g}l[W
 */


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <fstream>
#include <math.h>

#include "pako/pako_opengl_app.h"
#include "app_laster_shoot.h"
#include "ls_game_manager.h"


/*-----------------------------------------------------*/
/*                                                     */
/* Q[ViI                                      */
/*                                                     */
/*-----------------------------------------------------*/

/* ------------------------------ */
/* --- constructor/destructor     */
/* ------------------------------ */

PGameScenario::PGameScenario(void)
	: m_iPointer(0)
	, m_pEnemyMan(0)
{
	m_vScenario.clear();
}

PGameScenario::~PGameScenario(void)
{
}

/* ------------------------- */
/* ---  */
/**
 * Ȍ
 *
 * @param pEnemyMan [in] G}l[W̃CX^X
 */
void PGameScenario::Init(EnemyManage  *pEnemyMan, ItemMaker *pItemMaker)
{
	m_pEnemyMan = pEnemyMan;
	m_pItemMaker = pItemMaker;
	m_vScenario.clear();
	m_iPointer = 0;
}


/**
 * ViIf[^t@CǂݍŁAXe[WViIƂĕێ
 *
 * @param filename [in] ǂݍރViIt@C
 * @return ViĨIuWFNgA0ł炭݃G[
 */
int PGameScenario::Load(std::string &filename)
{
	std::fstream fsRead(filename, std::ios::in );
	int  param1, param2, param3;
	item obj;

	m_vScenario.clear();
	m_iPointer = 0;

	if (fsRead.fail() ) {
		return 0;
	}
	while( !fsRead.eof() ) {
		fsRead >> param1 >> param2 >> param3;
		obj.time = param1;
		obj.pos_x = param2;
		obj.charactor = param3;
		m_vScenario.push_back(obj);
	}

	//\[g
	std::sort(m_vScenario.begin(), m_vScenario.end(), PGameScenario::time_asc);

	return(m_vScenario.size());
}

/* ------------------------- */
/* ---  */

/**
 * ViIɃ{X̂邩グ
 * @return {X̐
 */
int PGameScenario::GetBossNum()
{
	int count = 0;
	std::vector<item>::iterator it;

	for(it=m_vScenario.begin(); it!=m_vScenario.end(); it++) {
		if ((it->charactor == 9) || (it->charactor == 10)) {
			count += 1;
		}
	}

	return(count);
}


/**
 * t[ɉViI̎s
 *
 * @param time [in] ̃Q[t[JEg
 * @return trueŐisAfalseŃViII
 */
bool PGameScenario::Execute(int timer)
{
	int num = m_vScenario.size();

	// ViI̍Ō܂ōs
	if (num <= m_iPointer) {
		return(false);
	}

	// t[ɉăIuWFNg
	while(m_vScenario[m_iPointer].time == timer) {
		if (m_vScenario[m_iPointer].charactor == 0) {
			// -- pow
			m_pItemMaker->doShot(static_cast<float>(m_vScenario[m_iPointer].pos_x), 0.0f);
		}
		else {
			int object = -1;
			for(int i=0; CharactorTable[i][0] != -1; i++) {
				if (CharactorTable[i][0] == m_vScenario[m_iPointer].charactor) {
					object = CharactorTable[i][1];
					break;
				}
			}
			if (object != -1) {
				if ((object == ENEMY_WALL1) || (object == ENEMY_WALL2)) {
					m_pEnemyMan->AddWall(object, static_cast<float>(m_vScenario[m_iPointer].pos_x), 0.0f);
				}
				else {
					m_pEnemyMan->AddEnemy(object, static_cast<float>(m_vScenario[m_iPointer].pos_x), 0.0f);
				}
			}
		}
		// -- next
		m_iPointer += 1;
		if (num <= m_iPointer) {
			break;
		}
	}

	return(true);
}




/*-----------------------------------------------------*/
/*                                                     */
/* Q[}l[W                                    */
/*                                                     */
/*-----------------------------------------------------*/

/* ------------------------------ */
/* --- constructor/destructor     */
/* ------------------------------ */

PGameManager::PGameManager(PakoSimpleApp *pApp, std::string &strStateName)
    : PakoStateMachine(pApp, strStateName)
	, m_iScore(0)
	, m_iMyshipRest(0)
	, m_iBossNum(0)
	, m_iGlobalTimer(0)
	, m_pMyshipMan(0)
	, m_pMyBulletMaker(0)
	, m_pEnemyMan(0)
	, m_pEnemyBulletMaker(0)
	, m_pItemMaker(0)
	, m_pScenario(0)
	, m_bBoss(false)
{
}

PGameManager::~PGameManager(void)
{
	delete  m_pScenario;
	delete 	m_pMyshipMan;
	delete  m_pMyBulletMaker;
	delete  m_pEnemyMan;
	delete  m_pEnemyBulletMaker;
	delete  m_pItemMaker;
}



/* ------------------------- */
/* --- O */
void PGameManager::onBegin(void)
{
	/* --- Q[ */
	m_iScore = 0;
	m_iMyshipRest = 3;
	m_iGlobalTimer = 0;
	m_iShotLevel = 1;

	/* --- IuWFNg}l[W̒` */
	m_pMyBulletMaker = new MyBulletMaker;
	m_pMyBulletMaker->Init(dynamic_cast<PakoOpenglApp*>(getApp()), SPLY_MYBULLET, BS_SPNUM_MYBULLET);
	m_pMyshipMan = new MyShipManage(dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_MYSHIP, 0));
	m_pMyshipMan->Init(m_pMyBulletMaker);
	m_pMyshipMan->SetShotLevel(m_iShotLevel);

	m_pItemMaker = new ItemMaker;
	m_pItemMaker->Init(dynamic_cast<PakoOpenglApp*>(getApp()), SPLY_MYBULLET, BS_SPNUM_MYBULLET);

	m_pEnemyBulletMaker = new EnemyBulletMaker;
	m_pEnemyBulletMaker->Init(dynamic_cast<PakoOpenglApp*>(getApp()), SPLY_BULLET, BS_SPNUM_BULLET);
	m_pEnemyMan = new EnemyManage;
	m_pEnemyMan->Init(dynamic_cast<PakoOpenglApp*>(getApp()), m_pEnemyBulletMaker, m_pMyshipMan, SPLY_ENEMY, SPLY_WALL);

	/* --- ViI̓ǂݍ */
	m_pScenario = new PGameScenario;
	m_pScenario->Init(m_pEnemyMan, m_pItemMaker);
	m_pScenario->Load(LS_SCENARIO_FILENAME);
	m_iBossNum = m_pScenario->GetBossNum();
	m_bBoss = false;

	/* --- Q[X^[g̃{CX */
	getApp()->getSound()->SE(SE_VOICE1);
}


/* ------------------------- */
/* --- ㏈ */
void PGameManager::onEnd(void)
{
    m_bExecute = false;
    /* Ǐ */
    if (m_iMyshipRest > 0) {
        m_strNextState = LS_STATE_GAME_MAIN_END_CLEAR_NAME;
    }
    else {
        m_strNextState = LS_STATE_GAME_MAIN_END_GAMEOVER_NAME;
    }
}



/* ------------------------------ */
/* --- main works                 */
/* ------------------------------ */

/* ------------------------- */
/* --- t[̏ */
void PGameManager::tick()
{
	bool alive = true;

	if (m_bBoss == false) {
		m_iGlobalTimer += 1;
	}

	m_pMyBulletMaker->tick();
	m_pEnemyBulletMaker->tick();
	m_pItemMaker->tick();

	alive = m_pMyshipMan->tick(getApp()->getInput()->getInput(0), getApp()->getInput()->getInputTriger(0));
	m_pEnemyMan->tick();

	/* --- ViILqɍ킹ăIuWFNg̐ */
	m_pScenario->Execute(m_iGlobalTimer);

	/* --- {X̓oƃQ[Ǘ */
	{
		bool boss = m_pEnemyMan->isAliveBoss();
		if ((true == boss) && (false == m_bBoss)) {
			getApp()->getSound()->Music(BGM_BOSS);
		}
		if ((false == boss) && (true == m_bBoss)) {
			m_iBossNum -= 1;
			if (m_iBossNum > 0) {
				/* ܂ */
				getApp()->getSound()->Music(BGM_MAIN1);
			}
			else {
				/* NAQ[I */
				onEnd();
			}
		}
		m_bBoss = boss;
	}

	/* --- ACe */
	{
		bool storeHitEnable = m_pMyshipMan->m_bHitEnable;
		// ACe͖GłE悤ɂ
		m_pMyshipMan->m_bHitEnable = (m_pMyshipMan->IsClash() == false);   // Aj͖
		if (m_pItemMaker->CheckHit(m_pMyshipMan)) {
			getApp()->getSound()->SE(SE_ITEM);
			m_pItemMaker->DisableAllBullet();
			if (m_iShotLevel < 3) {
				m_iShotLevel += 1;
				m_pMyshipMan->SetShotLevel(m_iShotLevel);
			}
		}
		m_pMyshipMan->m_bHitEnable = storeHitEnable;
	}
	/* --- qbg */
	if (m_pEnemyBulletMaker->CheckHit(m_pMyshipMan)) {
		getApp()->getSound()->SE(SE_MISS);
		m_pMyshipMan->SetHitState(true);
	}
	if (m_pEnemyMan->CheckMyshipHit(m_pMyshipMan)) {
		getApp()->getSound()->SE(SE_MISS);
		m_pMyshipMan->SetHitState(true);
	}
	m_iScore += m_pMyBulletMaker->CheckHit(m_pEnemyMan);

	/* --- ꂽƂAc@OŃQ[I */
	if (alive == false) {
		if (m_iShotLevel > 1) {
			m_iShotLevel -= 1;
			m_pMyshipMan->SetShotLevel(m_iShotLevel);
		}
		if (m_iMyshipRest > 0) {
			m_iMyshipRest -= 1;
		}
		if (m_iMyshipRest == 0) {
			onEnd();
		}
		else {
			m_pMyshipMan->Init(m_pMyBulletMaker);
		}
	}
}

/* ------------------------- */
/* --- t[̕\ */
void PGameManager::tickDisplay()
{
	m_pMyshipMan->tickDisplay();
	m_pMyBulletMaker->tickDisplay();
	m_pEnemyMan->tickDisplay();
	m_pEnemyBulletMaker->tickDisplay();
	m_pItemMaker->tickDisplay();

	/*  */
	if (dynamic_cast<PakoLasterShoot*>(getApp())->getDevelopDisp() == true) { 
		dispScore(m_iGlobalTimer, m_iMyshipRest);
	}
	else if (dynamic_cast<PakoLasterShoot*>(getApp())->getFramerateDisp() == true) { 
		dispScore(getApp()->m_SystemTime, m_iMyshipRest);
	}
	else {
		dispScore(m_iScore, m_iMyshipRest);
	}
	dispBackGround();
}


/* ------------------------------ */
/* --- Display work               */
/* ------------------------------ */

/* ------------------------------- */
/* --- XRAR\[̕\ */
void PGameManager::dispScore(int score, int rest)
{
	PakoSpriteItem *obj;

	/* --- wiVF[h */
	obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_SCORE, 0);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 32;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 704;
    obj->m_TexW = 640;
    obj->m_TexH = 32;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
	/* --- 'score:' */
	obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_SCORE, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 96;
    obj->m_SizeH = 32;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 352;
    obj->m_TexV = 736 + 1;
    obj->m_TexW = 96;
    obj->m_TexH = 32;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
	/* --- score */
	int n, k = 1000000;
	for(int i=0; i<7; i++) {
		n = (score / k) % 10;
		k /= 10;
		obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_SCORE, 2+i);
		obj->m_PosX = 100.0f + (i * 18);
		obj->m_PosY = 0.0f;
		obj->m_SizeW = 16;
		obj->m_SizeH = 32;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 32 * n;
		obj->m_TexV = 736 + 1;
		obj->m_TexW = 16;
		obj->m_TexH = 32;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = false;
		obj->m_Visible = true;
		obj->m_TextureID = 1;
	}
	/* --- rest */
	for(int i=0; i<5; i++) {
		obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_SCORE, 9+i);
		obj->m_PosX = 640.0f - 32.0f - (i * 32);
		obj->m_PosY = 0.0f;
		obj->m_SizeW = 32;
		obj->m_SizeH = 32;
		obj->m_Blend = 1.0f;
		obj->m_TexU = 320;
		obj->m_TexV = 736 + 1;
		obj->m_TexW = 32;
		obj->m_TexH = 32;
		obj->m_RollZ = 0.0f;
		obj->m_Zoom = 1.0f;
		obj->m_PosCenter = false;
		obj->m_Visible = (i < rest);
		obj->m_TextureID = 1;
	}
}

/* ------------------------------- */
/* --- wi̕\ */
void PGameManager::dispBackGround(void)
{
    PakoSpriteItem *obj;
	float  scr_y;

	scr_y = (0.35f * m_iGlobalTimer);
	scr_y = scr_y - (floor(scr_y / 480.0f) * 480.0f);

    /* obN̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_BACKGROUND2, 0);
    obj->m_PosX = 0.0f;
    obj->m_PosY = scr_y;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 0;
    obj->m_TexW = 640;
    obj->m_TexH = 479;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_BACKGROUND2, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = scr_y - 480.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 0;
    obj->m_TexW = 640;
    obj->m_TexH = 479;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;

	scr_y = (0.7f * m_iGlobalTimer);
	scr_y = scr_y - (floor(scr_y / 480.0f) * 480.0f);

    /* bV̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_BACKGROUND1, 0);
    obj->m_PosX = 0.0f;
    obj->m_PosY = scr_y;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 512;
    obj->m_TexW = 640;
    obj->m_TexH = 479;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_BACKGROUND1, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = scr_y - 480.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 512;
    obj->m_TexW = 640;
    obj->m_TexH = 479;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
}

