/**
 * V[eBOQ[{̂̃}l[W[
 *
 * Xe[g}VǗ͂ȂǂCt^CǗ̂߂
 * Xe[g}VNX𗘗p
 */

#ifndef LS_GAME_MANAGER_H
#define LS_GAME_MANAGER_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include <vector>

#include "pako/pako_state_machine.h"
#include "myshipmanage.h"
#include "enemymanage.h"


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

static std::string LS_STATE_GAME_MAIN_END_CLEAR_NAME    = "state::game::main::clear";
static std::string LS_STATE_GAME_MAIN_END_GAMEOVER_NAME = "state::game::main::gameover";

/* --- Q[ViIt@C */
static std::string LS_SCENARIO_FILENAME = "scenario.txt";

/* --- XvCgC[̒` */
enum SpriteLayer {
    SPLY_BACKGROUND2 = 0,
    SPLY_BACKGROUND1,
    SPLY_ENEMY,
    SPLY_MYBULLET,
    SPLY_BULLET,
    SPLY_WALL,
    SPLY_MYSHIP,
    SPLY_GAMEOVER,
    SPLY_SCORE
};

/* --- XvCgobt@ */
enum SpriteBufferSize {
	BS_SPNUM_BACKGROUND2 = 2,
	BS_SPNUM_BACKGROUND1 = 2,
	BS_SPNUM_ENEMY = 100,
	BS_SPNUM_MYBULLET = 100,
	BS_SPNUM_BULLET = 1000,
	BS_SPNUM_WALL = 20,
	BS_SPNUM_MYSHIP = 1,
	BS_SPNUM_GAMEOVER = 4,
	BS_SPNUM_SCORE = 14,
};

/* --- BGM̒` */
enum BgmIndex {
    BGM_MAIN1 = 1,
    BGM_GAMEOVER,
    BGM_CLEAR,
    BGM_TITLE,
    BGM_BOSS
};

/* --- SE̒` */
enum SeIndex {
    SE_BOSS_EXPLOSE = 1,
    SE_BOSS_HIT,
    SE_ITEM,
    SE_MISS,
    SE_SHOT,
    SE_VOICE1,
    SE_HIT
};

/* --- ViIƓGLN^[̕ϊtO */
static const int CharactorTable[][2] = {
	{  0, 0 }, // powerup
	{  1, ENEMY_ZAKO1 },
	{  2, ENEMY_ZAKO2 },
	{  3, ENEMY_ZAKO3 },
	{  4, ENEMY_ZAKO4 },
	{  5, ENEMY_ZAKO5 },
	{  6, ENEMY_ZAKO6 },
	{  7, ENEMY_CHUU1 },
	{  8, ENEMY_CHUU2 },
	{  9, ENEMY_BOSS1 },
	{ 10, ENEMY_BOSS2 },
	{ 11, ENEMY_WALL1 },
	{ 12, ENEMY_WALL2 },
	{ -1, -1 }
};


/*-------------------------------*/
/* class                         */
/*-------------------------------*/


/**
 * PGameScenario
 * G̏oViIǂݍݓKpNX
 */
class PGameScenario
{
public:
	struct item {
		int time;
		int pos_x;
		int charactor;
	};

	PGameScenario(void);
	virtual ~PGameScenario(void);

	//! 
	void Init(EnemyManage *pEnemyMan, ItemMaker *pItemMaker);
	//! ViIf[^̓ǂݍ
	int Load(std::string &filename);

	//! ViIɃ{X̂邩グ
	int GetBossNum();

	//! t[ɉViI̎s
	bool Execute(int timer);

	//! ViĨt[\[g]֐
	static bool time_asc( const item& left, const item& right ) { return left.time < right.time; }

protected:
	//! G}l[W
	EnemyManage  *m_pEnemyMan;
	ItemMaker    *m_pItemMaker;
	//! ViI
	std::vector<item> m_vScenario;
	//! ViIis|C^
	int  m_iPointer;

};


/**
 * PGameManager
 * Q[{̂̃IuWFNgǗȂǂŏʃNX
 */
class PGameManager : public PakoStateMachine
{
public:
    PGameManager(PakoSimpleApp *pApp, std::string &strStateName);
    ~PGameManager(void);

    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);

	/* --- Q[ViI */
	PGameScenario *m_pScenario;

	/* --- Q[IuWFNg */
	MyShipManage *m_pMyshipMan;
	EnemyManage  *m_pEnemyMan;
	
	/* --- eǗ */
	MyBulletMaker     *m_pMyBulletMaker;
	EnemyBulletMaker  *m_pEnemyBulletMaker;
	ItemMaker         *m_pItemMaker;

private:
	// Q[^C}[}bvisx
	int m_iGlobalTimer;
    // score
    int m_iScore;
    // myship c@
    int m_iMyshipRest;
    // BOSS c@
    int m_iBossNum;
	// BOSS otO
	bool m_bBoss;
	// Vbgx
	int m_iShotLevel;

	//! XRAR\[̕\
	void dispScore(int score, int rest);
	//! wî̕\
	void dispBackGround(void);
};


#endif
