/**
 * PAKO state machine
 * Q[Xe[g}l[W
 */


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_opengl_app.h"
#include "ls_state_game.h"
#include "ls_state_title.h"

#include "ls_game_manager.h"

/*-----------------------------------------------------*/
/*                                                     */
/* Q[Xe[g}l[W                            */
/*                                                     */
/*-----------------------------------------------------*/

/* ------------------------- */
/* --- O */
void PstmGame::onBegin(void)
{
    /* --- XvCgC[pӂ */
    /* gameover */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_GAMEOVER, BS_SPNUM_GAMEOVER, SPLY_GAMEOVER);
    /* score */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_SCORE, BS_SPNUM_SCORE, SPLY_SCORE);
    /* myship */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_MYSHIP, BS_SPNUM_MYSHIP, SPLY_MYSHIP);
    /* wall */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_WALL, BS_SPNUM_WALL, SPLY_WALL);
    /* bullet */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_BULLET, BS_SPNUM_BULLET, SPLY_BULLET);
    /* mybullet */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_MYBULLET, BS_SPNUM_MYBULLET, SPLY_MYBULLET);
    /* enemy */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_ENEMY, BS_SPNUM_ENEMY, SPLY_ENEMY);
    /* background 1 */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_BACKGROUND1, BS_SPNUM_BACKGROUND1, SPLY_BACKGROUND1);
    /* background 2 */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(SPLY_BACKGROUND2, BS_SPNUM_BACKGROUND2, SPLY_BACKGROUND2);

    /* --- Q[}l[W[̍쐬 */
    std::string  dummyname = "LsGameManager";
    m_pGameManager = new PGameManager(getApp(), dummyname);

	/* --- ^CgʃTuXe[gfBN^[ */
	{
		PstmGameSubStart *pState = new PstmGameSubStart(getApp(), LS_STATE_GAME_SUB_START_NAME);
		pState->setGameManager( m_pGameManager );
		addSubState(pState);
	}
	{
	    PstmGameSubMain *pState = new PstmGameSubMain(getApp(), LS_STATE_GAME_SUB_MAIN_NAME);
		pState->setGameManager( m_pGameManager );
		addSubState(pState);
	}
	{
		PstmGameSubGameover *pState = new PstmGameSubGameover(getApp(), LS_STATE_GAME_SUB_GAMEOVER_NAME);
		addSubState(pState);
	}
	{
		PstmGameSubClear *pState = new PstmGameSubClear(getApp(), LS_STATE_GAME_SUB_CLEAR_NAME);
		addSubState(pState);
	}

    /* TuXe[gJn */
    beginSubState(LS_STATE_GAME_SUB_START_NAME);

}


/* ------------------------- */
/* --- ㏈ */
void PstmGame::onEnd(void)
{
	/* --- Q[̔j */
	delete 	m_pGameManager;
	m_pGameManager = 0;

    /* --- XvCgC[̔j */
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_GAMEOVER);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_SCORE);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_MYSHIP);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_WALL);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_BULLET);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_MYBULLET);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_ENEMY);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_BACKGROUND1);
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(SPLY_BACKGROUND2);

    m_bExecute = false;

    /* Q[^Cgɖ߂ */
    m_strNextState = LS_STATE_TITLE_NAME;
}

/* ------------------------- */
/* --- t[̏ */
void PstmGame::tick()
{
    /* --- ɃTuXe[gs */
    if (doSubState() == false) {
        onEnd();
    }
}

/* ------------------------- */
/* --- t[̕\ */
void PstmGame::tickDisplay()
{
    doSubStateDisplay();
}




/*-----------------------------------------------------*/
/* step1: Q[ԏ                             */
/*-----------------------------------------------------*/

/* --- O */
void PstmGameSubStart::onBegin(void)
{
    /* CBGM */
    getApp()->getSound()->Music(BGM_MAIN1);

    /* Q[*/
	m_pGameManager->doReset();
}

/* --- ㏈ */
void PstmGameSubStart::onEnd(void)
{
    m_bExecute = false;
    m_strNextState = LS_STATE_GAME_SUB_MAIN_NAME;
}

/* --- t[̏ */
void PstmGameSubStart::tick()
{
    onEnd();
}

/* --- t[̕\ */
void PstmGameSubStart::tickDisplay()
{
}



/*-----------------------------------------------------*/
/* step2: Q[{̂̐s                             */
/*-----------------------------------------------------*/

/* --- O */
void PstmGameSubMain::onBegin(void)
{
    m_iTimer = 0;
}

/* --- ㏈ */
void PstmGameSubMain::onEnd(void)
{
    m_bExecute = false;
}

/* --- t[̏ */
void PstmGameSubMain::tick()
{
	if (m_pGameManager->isDone()) {
		std::string next;
		m_pGameManager->getNextState(next);
		if (next.find(LS_STATE_GAME_MAIN_END_CLEAR_NAME) == 0) {
		    m_strNextState = LS_STATE_GAME_SUB_CLEAR_NAME;
			onEnd();
		}
		else {
		    m_strNextState = LS_STATE_GAME_SUB_GAMEOVER_NAME;
			onEnd();
		}
	}
	m_pGameManager->tick();
}

/* --- t[̕\ */
void PstmGameSubMain::tickDisplay()
{
	if (m_pGameManager) {
		m_pGameManager->tickDisplay();
	}
}



/*-----------------------------------------------------*/
/* step3: Q[I[o[̗]C                         */
/*-----------------------------------------------------*/

/* --- O */
void PstmGameSubGameover::onBegin(void)
{
    getApp()->getSound()->MusicStop();
    m_iTimer = 0;
}

/* --- ㏈ */
void PstmGameSubGameover::onEnd(void)
{
    getApp()->getSound()->MusicStop();
    m_bExecute = false;
    m_strNextState = "";
}

/* --- t[̏ */
void PstmGameSubGameover::tick()
{
	if (m_iTimer == 15) {
	    /* Q[I[o[WO */
		getApp()->getSound()->MusicOneshot(BGM_GAMEOVER);
	}
    if (m_iTimer > 60) {
        if (getApp()->getInput()->getInputTriger(0) &
            (PakoSimpleApp::Input::IN_Button1 | PakoSimpleApp::Input::IN_Button2)) {
            onEnd();
        }
    }
    m_iTimer += 1;
}

/* --- t[̕\ */
void PstmGameSubGameover::tickDisplay()
{
	PakoSpriteItem *obj;
    /* VF[h\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(SPLY_GAMEOVER, 0);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 0.5f;
    obj->m_TexU = 320;
    obj->m_TexV = 1;
    obj->m_TexW = 8;
    obj->m_TexH = 8;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
}


/*-----------------------------------------------------*/
/* step4: Q[NA̗]C                           */
/*-----------------------------------------------------*/

/* --- O */
void PstmGameSubClear::onBegin(void)
{
    getApp()->getSound()->MusicStop();
    m_iTimer = 0;
}

/* --- ㏈ */
void PstmGameSubClear::onEnd(void)
{
    getApp()->getSound()->MusicStop();
    m_bExecute = false;
    m_strNextState = "";
}

/* --- t[̏ */
void PstmGameSubClear::tick()
{
	if (m_iTimer == 15) {
	    /* WO */
		getApp()->getSound()->MusicOneshot(BGM_CLEAR);
	}
    if (m_iTimer > 60) {
        if (getApp()->getInput()->getInputTriger(0) &
            (PakoSimpleApp::Input::IN_Button1 | PakoSimpleApp::Input::IN_Button2)) {
            onEnd();
        }
    }
    m_iTimer += 1;
}

/* --- t[̕\ */
void PstmGameSubClear::tickDisplay()
{
}

