/**
 * PAKO state machine
 * V[eBOQ[{̂̃Xe[g}V
 */

#ifndef LS_STATE_GAME_H
#define LS_STATE_GAME_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_state_machine.h"
#include "ls_game_manager.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

static std::string LS_STATE_GAME_NAME = "state::game";

static std::string LS_STATE_GAME_SUB_START_NAME  = "state::game::start";
static std::string LS_STATE_GAME_SUB_MAIN_NAME    = "state::game::main";
static std::string LS_STATE_GAME_SUB_GAMEOVER_NAME = "state::game::gameover";
static std::string LS_STATE_GAME_SUB_CLEAR_NAME = "state::game::clear";

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * PstmTitle - PAKO state machine
 * Q[̑O邽߂̃Xe[g}V
 */
class PstmGame : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmGame)
    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);
private:
    //Q[̃CX^X
    PGameManager *m_pGameManager;
};


/* -------------------------------- */
/* --- sub state machine */

/* --- 1. Q[JnO */
class PstmGameSubStart : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmGameSubStart)
    // v\bh
    void tick();
    void tickDisplay();

	void setGameManager( PGameManager *pGame ) { m_pGameManager = pGame; };

protected:
    void onBegin(void);
    void onEnd(void);
private:
    PGameManager *m_pGameManager;
};

/* --- 2. Q[C */
class PstmGameSubMain : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmGameSubMain)
    // v\bh
    void tick();
    void tickDisplay();

	void setGameManager( PGameManager *pGame ) { m_pGameManager = pGame; };

protected:
    void onBegin(void);
    void onEnd(void);
private:
    PGameManager *m_pGameManager;
    int m_iTimer;
};

/* --- 3. Q[I[o[ */
class PstmGameSubGameover : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmGameSubGameover)
    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);
private:
    int m_iTimer;
};

/* --- 4. NA */
class PstmGameSubClear : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmGameSubClear)
    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);
private:
    int m_iTimer;
};

#endif
