/**
 * PAKO state machine
 * Q[CXe[g}l[W
 * ^CgʁAQ[{҂ƂAvP[V܂Ƃ߂
 */


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_opengl_app.h"
#include "ls_state_title.h"
#include "ls_state_game.h"


/*-----------------------------------------------------*/
/*                                                     */
/* ^Cg}l[W                                  */
/*                                                     */
/*-----------------------------------------------------*/

/* ------------------------- */
/* --- O */
void PstmTitle::onBegin(void)
{
    PakoStateMachine* pState;

    /* --- XvCgC[ЂƂpӂ */
    dynamic_cast<PakoOpenglApp*>(getApp())->createSpriteLayer(0, 8, 1);

    /* --- ^CgʃTuXe[gfBN^[ */
    pState = new PstmTitleSubIn(getApp(), LS_STATE_TITLE_SUB_FADEIN_NAME);
    addSubState(pState);
    pState = new PstmTitleSubWait(getApp(), LS_STATE_TITLE_SUB_WAIT_NAME);
    addSubState(pState);
    pState = new PstmTitleSubOut(getApp(), LS_STATE_TITLE_SUB_FADEOUT_NAME);
    addSubState(pState);
    /* TuXe[gJn */
    beginSubState(LS_STATE_TITLE_SUB_FADEIN_NAME);
}


/* ------------------------- */
/* --- ㏈ */
void PstmTitle::onEnd(void)
{
    /* --- XvCgC[̔j */
    dynamic_cast<PakoOpenglApp*>(getApp())->deleteSpriteLayer(0);

    m_bExecute = false;
    /* Q[CɂȂ */
    m_strNextState = LS_STATE_GAME_NAME;
}

/* ------------------------- */
/* --- t[̏ */
void PstmTitle::tick()
{
    /* --- ɃTuXe[gs */
    if (doSubState() == false) {
        onEnd();
    }
}

/* ------------------------- */
/* --- t[̕\ */
void PstmTitle::tickDisplay()
{
    doSubStateDisplay();
}




/*-----------------------------------------------------*/
/* step1: ^CgtF[hC                         */
/*-----------------------------------------------------*/

/* --- O */
void PstmTitleSubIn::onBegin(void)
{
    /* ^Cg~[WbN */
    getApp()->getSound()->Music(4);

    m_iTimer = 0;
}

/* --- ㏈ */
void PstmTitleSubIn::onEnd(void)
{
    m_bExecute = false;
    m_strNextState = LS_STATE_TITLE_SUB_WAIT_NAME;
}

/* --- t[̏ */
void PstmTitleSubIn::tick()
{
    if (m_iTimer > 60) {
        onEnd();
    }
    m_iTimer += 1;
}

/* --- t[̕\ */
void PstmTitleSubIn::tickDisplay()
{
    PakoSpriteItem *obj;

    /* ^CgobN̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 0;
    obj->m_TexW = 640;
    obj->m_TexH = 480;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* ^CgS̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 2);
    obj->m_PosX = 320.0f;
    obj->m_PosY = 80.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 96;
    obj->m_Blend = m_iTimer / 60.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 480;
    obj->m_TexW = 640;
    obj->m_TexH = 96;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
}



/*-----------------------------------------------------*/
/* step2: ^CgX^[g҂                         */
/*-----------------------------------------------------*/

/* --- O */
void PstmTitleSubWait::onBegin(void)
{
    m_iTimer = 0;
	m_bPush = false;
}

/* --- ㏈ */
void PstmTitleSubWait::onEnd(void)
{
    m_bExecute = false;
    m_strNextState = LS_STATE_TITLE_SUB_FADEOUT_NAME;
}

/* --- t[̏ */
void PstmTitleSubWait::tick()
{
    unsigned int push;

    push = getApp()->getInput()->getInputTriger(0);
    if (push & (PakoSimpleApp::Input::IN_Button1 | PakoSimpleApp::Input::IN_Button2)) {
        getApp()->getSound()->SE(7);
    }
    push = getApp()->getInput()->getInput(0);
    if (push & (PakoSimpleApp::Input::IN_Button1 | PakoSimpleApp::Input::IN_Button2)) {
        m_bPush = true;
    }
    else {
        if (true == m_bPush) {
            onEnd();
        }
        m_bPush = false;
    }
    m_iTimer += 1;
}

/* --- t[̕\ */
void PstmTitleSubWait::tickDisplay()
{
    PakoSpriteItem *obj;

    /* ^CgobN̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 0;
    obj->m_TexW = 640;
    obj->m_TexH = 480;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* ^CgS̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 2);
    obj->m_PosX = 320.0f;
    obj->m_PosY = 80.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 96;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 480;
    obj->m_TexW = 640;
    obj->m_TexH = 96;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* X^[g{^ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 3);
    obj->m_PosX = 320.0f;
    obj->m_PosY = 480.0f - 80.0f;
    obj->m_SizeW = 320;
    obj->m_SizeH = 64;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 576 + (64 * (m_bPush == true));
    obj->m_TexW = 320;
    obj->m_TexH = 64;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
}



/*-----------------------------------------------------*/
/* step3: ^CgtF[hAEg                       */
/*-----------------------------------------------------*/

/* --- O */
void PstmTitleSubOut::onBegin(void)
{
    m_iTimer = 0;
}

/* --- ㏈ */
void PstmTitleSubOut::onEnd(void)
{
    getApp()->getSound()->MusicStop();
    m_bExecute = false;
    m_strNextState = "";
}

/* --- t[̏ */
void PstmTitleSubOut::tick()
{
    if (m_iTimer >= 30) {
        onEnd();
    }
    m_iTimer += 1;
}

/* --- t[̕\ */
void PstmTitleSubOut::tickDisplay()
{
    PakoSpriteItem *obj;
    float fadeout;

    fadeout = m_iTimer / 20.0f;
    if (fadeout > 1.0f) {
        fadeout = 1.0f;
    }

    /* ^CgobN̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 1);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 0;
    obj->m_TexW = 640;
    obj->m_TexH = 480;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* ^CgS̕\ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 2);
    obj->m_PosX = 320.0f;
    obj->m_PosY = 80.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 96;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 480;
    obj->m_TexW = 640;
    obj->m_TexH = 96;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* X^[g{^ */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 3);
    obj->m_PosX = 320.0f;
    obj->m_PosY = 480.0f - 80.0f;
    obj->m_SizeW = 320;
    obj->m_SizeH = 64;
    obj->m_Blend = 1.0f;
    obj->m_TexU = 0;
    obj->m_TexV = 576;
    obj->m_TexW = 320;
    obj->m_TexH = 64;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
    /* VF[h */
    obj = dynamic_cast<PakoOpenglApp*>(getApp())->getSpriteItem(0, 4);
    obj->m_PosX = 0.0f;
    obj->m_PosY = 0.0f;
    obj->m_SizeW = 640;
    obj->m_SizeH = 480;
    obj->m_Blend = fadeout;
    obj->m_TexU = 4;
    obj->m_TexV = 4;
    obj->m_TexW = 8;
    obj->m_TexH = 8;
    obj->m_RollZ = 0.0f;
    obj->m_Zoom = 1.0f;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 1;
}


