#include <stdlib.h>
#include <math.h>

#include "pako_math.h"
#include "pako_math_table.h"
#include "pako_math_table_int.h"

void PakoMath::Initialize(int seed)
{
  srand( (unsigned long) seed );
}

float PakoMath::Sin( long Angle )
{
  int  r;

  r = ((360 * Angle) / 65536) % 360;

  return(sprite_sin[r]);
}

float PakoMath::Cos( long Angle )
{
  int  r;

  r = ((360 * Angle) / 65536) % 360;

  return(sprite_cos[r]);
}

float PakoMath::Tan( long Angle )
{
  float  r, s;

  s = 3.1415926535f * 2 * (float)Angle / 360.0f;
  r = tanf(s);

  return(r);
}

long PakoMath::Atan( long Dx, long Dy )
{
  float  dig, r;

  dig = atan2((float)Dx, (float)(Dy));
  r = 65536.0f * dig / (3.1415926535f * 2);

  return((long)r);
}

long PakoMath::Rand( long Start, long End )
{
  return (rand() % (End - Start + 1)) + Start;
}

float PakoMath::RandF( void )
{
  long  r;

  r = Rand(0, 4096);
  return ((float)r / 4096.0f);
}
