/* ---------------------------------------------------------- */
/*  pako_opengl_app.cpp                                   */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief    Pako SDL Game Library - OpenGL application class
@author   rerofumi
@since    Nov.05.2006
*/
/*-----------------------------------------------------
Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <math.h>

#include "pako_opengl_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
PakoOpenglApp::PakoOpenglApp()
{
}

/**
* fXgN^(n)
*/
PakoOpenglApp::~PakoOpenglApp()
{
    /* --- XvCg̔j */
    sprite.clear();
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- initializeTexture() */
/**
* OpenGL ł̃eNX`pӂAĂ
*
*/
void PakoOpenglApp::initializeTexture(void)
{

    /* --- OpenGL texture K萔pӂĂ */
    glGenTextures(PAKO_TEXTURE_MAX, texID);

    for(int i=0; i<PAKO_TEXTURE_MAX; i++) {
        glBindTexture(GL_TEXTURE_2D, texID[i]);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,
            256, 256, 0, GL_RGBA,
            GL_UNSIGNED_BYTE, NULL);
    }

    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}


/* ----------------------------------------- */
/* --- readTexture() */
/**
* w̃eNX`ԍɃeNX`摜pӂ
*
* @param num [in] eNX`ԍ
* @param filename [in] eNX`摜t@C
* @return  0ŐAȊOŉ炩̃G[I
*
*/
int PakoOpenglApp::readTexture(int num, char *filename)
{
    SDL_Surface  *plane;

    /* --- ͈̓`FbN */
    if ((num < 0) || (num >= PAKO_TEXTURE_MAX) || (filename == 0)) {
        return(1);
    }

    /* --- eNX`ǂݍ */
    plane = IMG_Load(filename);
    if (plane == 0) {
        return(1);
    }

    /* --- OpenGL v[zɕϊ */
    setTextureFromSurface(num, plane);
    SDL_FreeSurface(plane);

    return(0);
}


/* ----------------------------------------- */
/* --- setTextureFromSurface() */
/**
* w̃eNX`ԍ SDL Surface 摜ݒ肷
*
* @param num [in] eNX`ԍ
* @param plane [in] eNX`摜Ƃ SDL surface
* @return  0ŐAȊOŉ炩̃G[I
*
*/
int PakoOpenglApp::setTextureFromSurface(int num, SDL_Surface *plane)
{
    SDL_Surface  *standard;
    SDL_Rect  rect1, rect2;
    int  tex_size, sq_size;
    int  i;

    /* --- ͈̓`FbN */
    if ((num < 0) || (num >= PAKO_TEXTURE_MAX) || (plane == 0)) {
        return(1);
    }

    /* --- 2^n ɍ킹 */
    if (plane->w > plane->h) {
        tex_size = plane->w;
    }
    else {
        tex_size = plane->h;
    }
    sq_size = 0;
    for(i=0; i<13; i++) {
        if ((1 << i) >= tex_size) {
            sq_size = (1 << i);
            break;
        }
    }
    if (sq_size == 0) {
        return(1);
    }
    /* - eNX`̃TCY */
    texSize[num].w = plane->w;
    texSize[num].h = plane->h;
    /* - 1pixel ̍WP */
    texSize[num].px = (1.0f / (float)plane->w) * ((float)plane->w / (float)sq_size);
    texSize[num].py = (1.0f / (float)plane->h) * ((float)plane->h / (float)sq_size);

    /* --- OpenGL v[zɕϊ */
    standard = SDL_CreateRGBSurface(SDL_SWSURFACE,
        sq_size, sq_size, 32,
#if SDL_BYTEORDER == SDL_LIL_ENDIAN /* OpenGL RGBA masks */
        0x000000FF, 
        0x0000FF00, 
        0x00FF0000, 
        0xFF000000
#else
        0xFF000000,
        0x00FF0000, 
        0x0000FF00, 
        0x000000FF
#endif
        );
    rect1.x = rect1.y = 0;
    rect2.x = rect2.y = 0;
    rect1.w = plane->w;
    rect1.h = plane->h;
    rect2.w = plane->w;
    rect2.h = plane->h;
    SDL_SetAlpha(plane, 0, 0);
    SDL_BlitSurface(plane, &rect1, standard, &rect2);

    /* --- OpenGL texture */
    glBindTexture(GL_TEXTURE_2D, texID[num]);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,
        sq_size, sq_size,
        0, GL_RGBA,
        GL_UNSIGNED_BYTE,
        standard->pixels);

    return(0);
}


/* ----------------------------------------- */
/* --- selectTexture() */
/**
* wԍ̃eNX`IALɂ
*
* @param num [in] eNX`ԍ
* @return  0ŐAȊOŉ炩̃G[I
*
*/
int PakoOpenglApp::selectTexture(int num)
{
    glBindTexture(GL_TEXTURE_2D, texID[num]);
    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

    return(0);
}


/* ----------------------------------------- */
/* --- disableTexture() */
/**
* Jgł̃eNX`𖳌ɂ
* O glDisable() Ăł\Ȃ
*
*/
void PakoOpenglApp::disableTexture(void)
{
    glDisable(GL_TEXTURE_2D);
}


/* ----------------------------------------- */
/* --- disableTexture() */
/**
* Jgł̃eNX`Lɂ
* O glEnable() Ă񂾕ׂݒł
*
*/
void PakoOpenglApp::enableTexture(void)
{
    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}




/* ----------------------------------------- */
/* --- initializeSprite() */
/**
* XvCg̏
*
*/
void PakoOpenglApp::initializeSprite(void)
{
    float screen_aspect;

    /* --- WnwW */
    if (m_WindowSizeW > m_WindowSizeH) {
        screen_aspect = (float)m_WindowSizeH / (float)m_WindowSizeW;
        sprite_screen_px = 1.0f / (float)(m_WindowSizeW / 2);
        sprite_screen_py = -(screen_aspect / (float)(m_WindowSizeH / 2));
        sprite_screen_home_x = -1.0f;
        sprite_screen_home_y = screen_aspect;
    }
    else {
        screen_aspect = (float)m_WindowSizeW / (float)m_WindowSizeH;
        sprite_screen_px = screen_aspect / (float)(m_WindowSizeW / 2);
        sprite_screen_py = -(1.0f / (float)(m_WindowSizeH / 2));
        sprite_screen_home_x = -screen_aspect;
        sprite_screen_home_y = 1.0f;
    }
    /* --- XvCgC[Sj */
    sprite.clear();
}


/* ----------------------------------------- */
/* --- createSpriteLayer() */
/**
* XvCgC[̃}l[W𐶐Xgɒǉ
*
* @param layer [in] V}l[Wɕt郌C[ID
* @param size [in] VXvCg}l[WǗXvCg̐
* @param depth [in] C[\ۂ̗D揇
* @return 0ŐȊOŎs(ɃC[)
*
*/
/* - \[g֐ */
struct sprite_depth_sort
{
    bool operator()(const PakoSpriteManage& a, const PakoSpriteManage& b) const {
        return(b.m_depth > a.m_depth);
    }
};

int PakoOpenglApp::createSpriteLayer(int layer, int size, int depth)
{
    vector<PakoSpriteManage>::iterator it;
    PakoSpriteManage *new_layer;

    /* --- layer ID ̏d`FbN */
    for(it=sprite.begin(); it!=sprite.end(); it++) {
        if (it->m_layer == layer) {
            /* - ̂ŃG[ */
            return(1);
        }
    }

    /* --- VXvCg}l[W̐ */
    new_layer = new PakoSpriteManage;
    new_layer->m_layer = layer;
    new_layer->m_depth = depth;
    new_layer->setSize(size);

    /* --- Xgɒǉ */
    sprite.push_back(*new_layer);
    //delete new_layer;

    /* --- depth Ƀ\[g */
    sort(sprite.begin(), sprite.end(), sprite_depth_sort());

    return(0);
}


/* ----------------------------------------- */
/* --- deleteSpriteLayer() */
/**
* w̃XvCgC[j
*
* @param layer [in] 폜郌C[ID
* @return 0ŐȊOŎs(ɃC[)
*
*/
int PakoOpenglApp::deleteSpriteLayer(int layer)
{
    vector<PakoSpriteManage>::iterator it;
    int r;

    r = 1;

    /* --- layer ID }l[W[{ */
    for(it=sprite.begin(); it!=sprite.end(); it++) {
        if (it->m_layer == layer) {
            /* - ̂ō폜 */
            sprite.erase(it);
            r = 0;
            break;
        }
    }

    return(r);
}


/* ----------------------------------------- */
/* --- getSpriteItem() */
/**
* w̃XvCgACen
*
* @param layer [in] C[ID
* @param item [in] XvCgԍ
* @return ŃXvCg̃|C^ 0Ŏs(݂ȂACe̎w)
*
*/
PakoSpriteItem *PakoOpenglApp::getSpriteItem(int layer, int item)
{
    vector<PakoSpriteManage>::iterator it;
    PakoSpriteItem *obj;

    obj = 0;

    /* --- layer ID }l[W[{ */
    for(it=sprite.begin(); it!=sprite.end(); it++) {
        if (it->m_layer == layer) {
            /* - ̂ŃXvCgo */
            obj = it->getSprite(item);
            break;
        }
    }

    return(obj);
}


/* ----------------------------------------- */
/* --- getReserveSprite() */
/**
* w̃XvCgACen
*
* @param layer [in] C[ID
* @param item [out] XvCg擾łƂ̔ԍԂ
* @return ŃXvCg̃|C^ 0Ŏs
*
*/
PakoSpriteItem *PakoOpenglApp::getReserveSprite(int layer, int *index)
{
    vector<PakoSpriteManage>::iterator it;
    PakoSpriteItem *obj;

    obj = 0;
	*index = -1;

    /* --- layer ID }l[W[{ */
    for(it=sprite.begin(); it!=sprite.end(); it++) {
        if (it->m_layer == layer) {
            /* - ̂ŃXvCgo */
            obj = it->getReserveSprite(index);
            break;
        }
    }

    return(obj);
}


/* ----------------------------------------- */
/* --- displaySprite() */
/**
* XvCg̕\
*
*/
void PakoOpenglApp::displaySprite(void)
{
    vector<PakoSpriteManage>::iterator it;
    PakoSpriteItem *obj;
    int  i, sploop;
    float  x[4], y[4];
    float  rs, rc, rx, ry;
    float  u, v, uw, vh;
    float  screen_aspect;
    float  lw, lh;

    /* --- OpenGL Ńv[ */
    glDisable(GL_DEPTH_TEST); 
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (m_WindowSizeW > m_WindowSizeH) {
        screen_aspect = (float)m_WindowSizeH / (float)m_WindowSizeW;
        glOrtho(-1.0, 1.0, screen_aspect, -screen_aspect, -1.0, 1.0);
    }
    else {
        screen_aspect = (float)m_WindowSizeW / (float)m_WindowSizeH;
        glOrtho(-screen_aspect, screen_aspect, 1.0, -1.0, -1.0, 1.0);
    }
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    /* --- S layer ɑ΂čs */
    for(it=sprite.begin(); it!=sprite.end(); it++) {
        sploop = it->getSize();
        for(i=0; i<sploop; i++) {
            obj = it->getSprite(i);
            if (obj == 0) continue;
            if (obj->m_Visible == true) {
                /* -- XvCgACe̕\ */
                /* - ʒu */
                lw = (sprite_screen_px * obj->m_SizeW);
                lh = (sprite_screen_py * obj->m_SizeH);
                if (obj->m_PosCenter == false) {
                    x[0] = 0.0;
                    y[0] = -lh;
                    x[1] = x[0];
                    y[1] = 0;
                    x[2] = x[0] + lw;
                    y[2] = 0;
                    x[3] = x[0] + lw;
                    y[3] = -lh;
                }
                else {
                    x[0] = -lw * 0.5f;
                    y[0] = -lh * 0.5f;
                    x[1] = x[0];
                    y[1] = y[0] + lh;
                    x[2] = x[0] + lw;
                    y[2] = y[0] + lh;
                    x[3] = x[0] + lw;
                    y[3] = y[0];
                }
                /* - ] */
                if (obj->m_RollZ != 0.0) {
                    rs = sin(3.1415926535f * 2.0f * obj->m_RollZ);
                    rc = cos(3.1415926535f * 2.0f * obj->m_RollZ);
                    rx = x[0]*rc - y[0]*rs;
                    ry = x[0]*rs + y[0]*rc;
                    x[0] = rx; y[0] = ry;
                    rx = x[1]*rc - y[1]*rs;
                    ry = x[1]*rs + y[1]*rc;
                    x[1] = rx; y[1] = ry;
                    rx = x[2]*rc - y[2]*rs;
                    ry = x[2]*rs + y[2]*rc;
                    x[2] = rx; y[2] = ry;
                    rx = x[3]*rc - y[3]*rs;
                    ry = x[3]*rs + y[3]*rc;
                    x[3] = rx; y[3] = ry;
                }
                /* - gk */
                if (obj->m_Zoom != 1.0) {
                    x[0] *= obj->m_Zoom;
                    y[0] *= obj->m_Zoom;
                    x[1] *= obj->m_Zoom;
                    y[1] *= obj->m_Zoom;
                    x[2] *= obj->m_Zoom;
                    y[2] *= obj->m_Zoom;
                    x[3] *= obj->m_Zoom;
                    y[3] *= obj->m_Zoom;
                }
                /* - sړ */
                u = sprite_screen_home_x + (sprite_screen_px * obj->m_PosX);
                v = - sprite_screen_home_y - (sprite_screen_py * obj->m_PosY);
                x[0] += u;
                y[0] += v;
                x[1] += u;
                y[1] += v;
                x[2] += u;
                y[2] += v;
                x[3] += u;
                y[3] += v;
                /* - eNX`W */
                u = obj->m_TexU * texSize[obj->m_TextureID].px;
                v = obj->m_TexV * texSize[obj->m_TextureID].py;
                uw = obj->m_TexW * texSize[obj->m_TextureID].px;
                vh = obj->m_TexH * texSize[obj->m_TextureID].py;
                /* - \ */
                selectTexture(obj->m_TextureID);
                glColor4f(1.0, 1.0, 1.0, obj->m_Blend);
                glBegin(GL_POLYGON);
                glTexCoord2f(u, v+vh);
                glVertex2f(x[0], y[0]);
                glTexCoord2f(u+uw, v+vh);
                glVertex2f(x[3], y[3]);
                glTexCoord2f(u+uw, v);
                glVertex2f(x[2], y[2]);
                glTexCoord2f(u, v);
                glVertex2f(x[1], y[1]);
                glEnd();
				if (obj->m_Flash == true) {
					glEnable(GL_BLEND);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE);
					glColor4f(1.0, 1.0, 1.0, obj->m_Blend);
					glBegin(GL_POLYGON);
					glTexCoord2f(u, v+vh);
					glVertex2f(x[0], y[0]);
					glTexCoord2f(u+uw, v+vh);
					glVertex2f(x[3], y[3]);
					glTexCoord2f(u+uw, v);
					glVertex2f(x[2], y[2]);
					glTexCoord2f(u, v);
					glVertex2f(x[1], y[1]);
					glEnd();
					glEnable(GL_BLEND);
					glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				}
            }
        }
    }
    disableTexture();
    glDisable(GL_BLEND);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
}





/*------------------------------------------------------*/
/* protected method                                     */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- onBoot() */
/**
* SDL pʐݒ̏ۂɍs
*
* @return 0ŒʏIAȊOŃG[vʒm
*
*/
int PakoOpenglApp::onBoot(void)
{
    int  r;

    /* --- super */
#ifdef __PSP__
    r = PakoPSPOpenglApp::onBoot();
#else
    r = PakoSDLOpenglApp::onBoot();
#endif
    if (r != 0) {
        return(1);
    }

    /* --- texture manage Jn */
    initializeTexture();

    /* --- sprite manage Jn */
    initializeSprite();

    return(0);
}


/* ----------------------------------------- */
/* --- onShutdown() */
/**
* execute ̏IĂяo㏈\bh
* VXe̔j
*
* @return 0ŒʏIAȊOŃG[vʒm
*
*/
int PakoOpenglApp::onShutdown(void)
{
#ifdef __PSP__
	PakoEsOpenglApp::onShutdown();
#else 
	PakoSDLOpenglApp::onShutdown();
#endif

    /* --- OpenGL texture Ă */
    glDeleteTextures(PAKO_TEXTURE_MAX, texID);

    /* --- XvCg̉ */
    /* === */

    return(0);
}


/*------------------------------------------------------*/
/* local method                                         */
/*------------------------------------------------------*/
