/* ---------------------------------------------------------- */
/*  pako_opengl_app.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - OpenGL application class
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PAKO_OPENGL_APP_H
#define PAKO_OPENGL_APP_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <vector>
#include <algorithm>

#include "SDL.h"
#include "SDL_image.h"

#ifdef __PSP__
#include "pako_es_opengl_app.h"
#else
#include "pako_sdl_opengl_app.h"
#endif
#include "pako_spritemanage.h"


using namespace std;

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

//! eNX`̊Ǘő吔
#define PAKO_TEXTURE_MAX   16


/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

typedef struct {
  int  w, h;
  float px, py;
} TextureSize;

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief SDL-Opengl Q[AvP[VNX
 *        PCł Opengl \NX
 *
 * @todo -
 * @bug -
 */
#ifdef __PSP__
class PakoOpenglApp : public PakoEsOpenglApp
#else 
class PakoOpenglApp : public PakoSDLOpenglApp
#endif
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  PakoOpenglApp();
  virtual  ~PakoOpenglApp();

  /* ----------------------------------- */
  /* --- pubNo */
 public:

  /* ----------------------------------- */
  /* --- thNXo */
 protected:
  //! OpenGL ɂeNX`ԍ蓖
  unsigned int  texID[PAKO_TEXTURE_MAX];
  //! eNX`̃sNZTCY
  TextureSize  texSize[PAKO_TEXTURE_MAX];
  //! XvCgC[Xg
  vector<PakoSpriteManage>  sprite;

  /* ----------------------------------- */
  /* --- vCx[go */
 private:
  //! XN[ 1Pixel  2D Wl
  float sprite_screen_home_x;
  float sprite_screen_home_y;
  float sprite_screen_px;
  float sprite_screen_py;

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  void initializeTexture(void);
  int readTexture(int num, char *filename);
  int setTextureFromSurface(int num, SDL_Surface *plane);
  int selectTexture(int num);
  void disableTexture(void);
  void enableTexture(void);
  void initializeSprite(void);
  int createSpriteLayer(int layer, int size, int depth);
  int deleteSpriteLayer(int layer);
  PakoSpriteItem *getSpriteItem(int layer, int item);
  PakoSpriteItem *getReserveSprite(int layer, int *index);
  void displaySprite(void);
  

  /* ----------------------------------- */
  /* --- thNX\bh */
 protected:
  virtual int onBoot(void);
  virtual int onShutdown(void);

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:

};


#endif

