/* ---------------------------------------------------------- */
/*  Pako_SpriteItem.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - sprite item
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2005 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "pako_spriteitem.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoSpriteItem::PakoSpriteItem()
{
  /* ---  */
  m_Working = false;
  m_Visible = false;
  m_Flash = false;
  m_PosX = 0.0;
  m_PosY = 0.0;
  m_SizeW = 0;
  m_SizeH = 0;
  m_Priority = 0;
  m_Blend = 1.0;
  m_Zoom = 1.0;
  m_TexU = 0;
  m_TexV = 0;
  m_TexW = 0;
  m_TexH = 0;
  m_RollZ = 0.0;
  m_RollX = 0.0;
  m_RollY = 0.0;
  m_TextureID = 0;
}

PakoSpriteItem::PakoSpriteItem(const PakoSpriteItem& other)
{
  if (this != &other) {
    m_Working = other.m_Working;
    m_Visible = other.m_Visible;
	m_Flash = other.m_Flash;
    m_PosX = other.m_PosX;
    m_PosY = other.m_PosY;
    m_SizeW = other.m_SizeW;
    m_SizeH = other.m_SizeH;
    m_Priority = other.m_Priority;
    m_Blend = other.m_Blend;
    m_Zoom = other.m_Zoom;
    m_TexU = other.m_TexU;
    m_TexV = other.m_TexV;
    m_TexW = other.m_TexW;
    m_TexH = other.m_TexH;
    m_RollZ = other.m_RollZ;
    m_RollX = other.m_RollX;
    m_RollY = other.m_RollY;
    m_TextureID = other.m_TextureID;
  }
}

/**
 * fXgN^(n)
 */
PakoSpriteItem::~PakoSpriteItem()
{
}


/**
 * Zq
 */
PakoSpriteItem& PakoSpriteItem::operator=(const PakoSpriteItem& other)
{
  if (this != &other) {
    m_Working = other.m_Working;
    m_Visible = other.m_Visible;
    m_PosX = other.m_PosX;
    m_PosY = other.m_PosY;
    m_SizeW = other.m_SizeW;
    m_SizeH = other.m_SizeH;
    m_Priority = other.m_Priority;
    m_Blend = other.m_Blend;
    m_Zoom = other.m_Zoom;
    m_TexU = other.m_TexU;
    m_TexV = other.m_TexV;
    m_TexW = other.m_TexW;
    m_TexH = other.m_TexH;
    m_RollZ = other.m_RollZ;
    m_RollX = other.m_RollX;
    m_RollY = other.m_RollY;
    m_TextureID = other.m_TextureID;
  }
  return *this;
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/


/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

