/* ---------------------------------------------------------- */
/*  Pako_SpriteManage.cpp                                     */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief    Pako SDL Game Library - sprite list manage
@author   rerofumi
@since    Nov.06.2006
*/
/*-----------------------------------------------------
Copyright (C) 2005 fumi2kick/rerofumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "pako_spritemanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
PakoSpriteManage::PakoSpriteManage()
{
	/* ---  */
	m_size = 0;
	obj = 0;
	m_reverse_priority = false;
	m_layer = 0;
}

PakoSpriteManage::PakoSpriteManage(const PakoSpriteManage& other)
{
	if (this != &other) {
		m_layer = other.m_layer;
		m_depth = other.m_depth;
		m_reverse_priority = other.m_reverse_priority;
		m_size = other.m_size;
		if (m_size > 0) {
			obj = new PakoSpriteItem[m_size];
			for(int i=0; i<m_size; i++) {
				obj[i] = other.obj[i];
			}
		}
	}
}


/**
* fXgN^(n)
*/
PakoSpriteManage::~PakoSpriteManage()
{
	if (m_size > 0) {
		delete[] obj;
		m_size = 0;
		obj = 0;
	}
}


/**
* Zq
*/
PakoSpriteManage& PakoSpriteManage::operator=(const PakoSpriteManage& other)
{
	if (this != &other) {
		m_layer = other.m_layer;
		m_depth = other.m_depth;
		m_reverse_priority = other.m_reverse_priority;
		m_size = other.m_size;
		if (m_size > 0) {
			delete[] obj;
			obj = new PakoSpriteItem[m_size];
			for(int i=0; i<m_size; i++) {
				obj[i] = other.obj[i];
			}
		}
	}
	return *this;
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- setSize() */
/**
* w萔̃XvCgACezƂėpӂ
* ɃXvCgۗLĂꍇ͔j
*
* @param size [in] VKɊmۂXvCgACe̐
*
*/
void  PakoSpriteManage::setSize(int size)
{
	/* --- ͈̓`FbN */
	if (size < 0) {
		return;
	}

	/* --- ݂̃XvCgzj */
	delete[] obj;
	obj = 0;

	/* --- VKɊm */
	obj = new PakoSpriteItem[size];
	m_size = size;

	/* --- S\ɂĂ */
	for(int i=0; i<size; i++) {
		obj[i].m_Visible = false;
		obj[i].m_Working = false;
	}
}


/* ----------------------------------------- */
/* --- getSize() */
/**
* ݕۗLĂXvCg̐n
*
* @return ݕۗLĂXvCgACe̐
*
*/
int  PakoSpriteManage::getSize(void)
{
	return(m_size);
}


/* ----------------------------------------- */
/* --- getSprite() */
/**
* w肳ꂽԍ̃XvCgACen
*
* @paran item [in] EXvCg̃CfbNXԍ
* @return XvCgACeNX|C^AG[ 0
*
*/
PakoSpriteItem *PakoSpriteManage::getSprite(int item)
{
	int num;

	/* --- ͈̓`FbN */
	if ((item < 0) || (m_size <= item)) {
		return(0);
	}

	if (m_reverse_priority == true) {
		num = (m_size - item) - 1;
	}
	else {
		num = item;
	}

	return(&obj[num]);
}

/* ----------------------------------------- */
/* --- getReserveSprite() */
/**
* w肳ꂽԍ̃XvCgACen
*
* @paran item [out] EXvCg̃CfbNXԍ
* @return XvCgACeNX|C^AG[ 0
*/
PakoSpriteItem *PakoSpriteManage::getReserveSprite(int *item)
{
	PakoSpriteItem *pSprite = 0;
	*item = 0;

	for(int i=0; i<m_size; i++) {
		if (obj[i].m_Working == false && obj[i].m_Visible == false) {
			*item = i;
			pSprite = &obj[i];
			break;
		}
	}

	return(pSprite);
}


/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

