/* ---------------------------------------------------------- */
/*  pako_state_machine.h                                      */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - state machine & manage class
    @author   rerofumi
    @since    Apr.09.2011
*/
/*-----------------------------------------------------
 Copyright (C) 2011 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PAKO_STATE_MACHINE_H
#define PAKO_STATE_MACHINE_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <string>
#include <map>


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* -------------------------------------------------------------------------
 --- Reference

 ----- gXe[g}l[W[ƂȂꍇ
   1) onBegin ̒ŕKvȃTuXe[g𐶐addSubState()
   2) onBegin ̒ beginSubState() ɍŏɎsTuXe[gď
   3) tick ̒ doSubState() ĂԁAfalse AĂ onEnd() ŏI
   4) tickDisplay ̒ł doSubStetaDisplay() Ăł

 ----- g̓Xe[ĝЂƂłꍇ
   1) onExecute  m_bInitialize 𗧂ĂĂ
   2) m_bInitialize Ă tick ̓ onBegin Ă΂
   3) tick ̒œK؂ȏ
   4) tickDisplay ̂ȂœK؂ȕ\
   5) g̏ m_strNextState ɐi߂Xe[g onEnd ŏI

----------------------------------------------------------------------------*/

/* --- convenience macro */
#define CONSTRUCT_PAKO_STATE_MACHINE(name) name(PakoSimpleApp *pApp, std::string &strStateName) \
        : PakoStateMachine(pApp, strStateName) {}; \
    ~name(void) {};
/* - - - - - */

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

class PakoSimpleApp;

/**
 * @brief SDL-Opengl Xe[g}VNX
 *        Q[isXebv̎NX
 *        gXe[gɂȂ邱ƂAXe[gǗ邱Ƃł
 * @todo -
 * @bug -
 */
class PakoStateMachine
{
    /* ----------------------------------- */
    /* --- RXgN^EfXgN^ */
public:
    PakoStateMachine(PakoSimpleApp *pApp, const std::string &strStateName);
    virtual  ~PakoStateMachine();

    /* ----------------------------------- */
    /* --- pubNo */
public:
    //! eƂȂAvP[VNX̃CX^X
    PakoSimpleApp *m_pAppClass;

    /* ----------------------------------- */
    /* --- thNXo */
protected:
    //! ǗTuXe[g}V
    std::map<std::string, PakoStateMachine*>  m_mapSubState;

    //! ̃Xe[g
    std::string  m_strStateName;
    //! stO
    bool m_bExecute;
    //! ̃Xe[g
    std::string  m_strNextState;
    //! ݂̃TuXe[g
    std::string  m_strSubState;

    /* ----------------------------------- */
    /* --- vCx[go */
private:

    /* ----------------------------------- */
    /* --- pubN\bh */
public:
    //! t[̎sC
    virtual void tick(void);
    virtual void tickDisplay(void);

    //! ̃Xe[gn
    void getName(std::string &strName);
    //! ̃Xe[gŏs
    void doReset();
    //! f
    void doStop();
    //! AvP[VNX̃CX^Xn
    PakoSimpleApp *getApp();
    //! ̃Xe[gIn
    bool isDone();
    //! ɈڍsXe[gʂɓn
    bool getNextState(std::string &strNextStateName);

    /* ----------------------------------- */
    /* --- thNX\bh */
protected:
    virtual void onBegin(void);
    virtual void onEnd(void);

    //! Xe[gTuXe[g擾
    PakoStateMachine *getSubState(std::string &strName);
    //! TuXe[gǗɒǉ
    void addSubState(PakoStateMachine *stm);
    //! w薼̃TuXe[g}Vs
    bool beginSubState(std::string &strSubStateName);
    //! TuXe[g}V̎s
    bool doSubState();
    void doSubStateDisplay();
	//! TuXe[g}VׂĊǗ
	void freeSubState(void);

    /* ----------------------------------- */
    /* --- vCx[g\bh */
private:

};


#endif
