/* ---------------------------------------------------------- */
/*  shootingobject.cpp                                        */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		蔻tXvCg
@author		K.Kunikane (rerofumi)
@since		Feb.14.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------
Apr.10.2011 - PAKO game system ɘA
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "shootingobject.h"

#include <math.h>

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
ShootingObject::ShootingObject(PakoSpriteItem *SpriteInstance)
	:m_pSprite(SpriteInstance)
	,m_bGrazeEnable(false)
	,m_bHitEnable(false)
	,m_fHitR(0.0)
	,m_fHitPow(0.0)
	,m_fGrazeR(0.0)
	,m_fGrazePow(0.0)
	,m_bSquareHit(false)
{
}


/**
* fXgN^(n)
*/
ShootingObject::~ShootingObject()
{
	m_pSprite->m_Visible = false;
	m_pSprite->m_Working = false;
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- SetHitSize() */
/**
* ̃IuWFNg̓蔻蔼aZbg
*
* @param r [in] IuWFNg蔻̔a
*/
void ShootingObject::SetHitSize(float r)
{
	m_fHitR = r;
	m_fHitPow = r * r;
}

/**
* ̃IuWFNg̓蔻Zbg
*
* @param w [in] IuWFNg蔻̉
* @param h [in] IuWFNg蔻̏c
*/
void  ShootingObject::SetHitSize(float w, float h)
{
	m_fHitRectW = w;
	m_fHitRectH = h;
}


/* ----------------------------------------- */
/* --- SetGrazeSize() */
/**
* ̃IuWFNĝ蔻蔼aZbg
*
* @param r [in] IuWFNg蔻̔a
* @return 
*
*/
void ShootingObject::SetGrazeSize(float r)
{
	m_fGrazeR = r;
	m_fGrazePow = r * r;
}

/* ----------------------------------------- */
/* --- CheckCollision() */
/**
* IuWFNgm̓蔻
* ܂ɋ`Ŕʂ߂Ȃ~̏Փ˔
*
* @return Ȃ\ true s false
*
*/
bool ShootingObject::CheckCollision(ShootingObject* obj)
{
	if (m_bSquareHit) {
		return checkCollisionBox(obj);
	}
	else {
		return checkCollisionRound(obj);
	}
}

bool ShootingObject::checkCollisionRound(ShootingObject* obj)
{
	float  dx, dy, dr;
	bool quick;

	/* --- LȃIuWFNgłȂI */
	if (m_bHitEnable == false) {
		return(false);
	}
	if (obj->m_bHitEnable == false) {
		return(false);
	}
	quick = true;
	dr = m_fHitR + obj->m_fHitR;
	dx = m_pSprite->m_PosX - obj->m_pSprite->m_PosX;
	dy = m_pSprite->m_PosY - obj->m_pSprite->m_PosY;
	/* --- ȈՔ肻1 */
	if (dx < 0) {
		dx *= (-1.0);
		if (dx > dr) {
			quick = false;
		}
	}
	else {
		if (dx > dr) {
			quick = false;
		}
	}
	/* - x ̊J傫AƏI */
	if (quick == false) {
		return(false);
	}
	/* --- ȈՔ肻2 */
	if (dy < 0) {
		dy *= (-1.0);
		if (dy > dr) {
			quick = false;
		}
	}
	else {
		if (dy > dr) {
			quick = false;
		}
	}
	/* - y ̊J傫AƏI */
	if (quick == false) {
		return(false);
	}
	/* --- ʂɉ~̋Ŕ */
	dx *= dx;
	dy *= dy;
	dr *= dr;
	dx += dy;
	if (dr < dx) {
		return(false);
	}

	return(true);
}

bool ShootingObject::checkCollisionBox(ShootingObject* obj)
{
	float  dx, dy, dr;
	bool quick;

	/* --- LȃIuWFNgłȂI */
	if (m_bHitEnable == false) {
		return(false);
	}
	if (obj->m_bHitEnable == false) {
		return(false);
	}
	quick = true;
	/* ---  */
	dr = (m_fHitRectW + obj->m_fHitRectW) * 0.5f;
	dx = abs(m_pSprite->m_PosX - obj->m_pSprite->m_PosX);
	if (dx > dr) {
		return(false);
	}
	/* --- c */
	dr = (m_fHitRectH + obj->m_fHitRectH) * 0.5f;
	dy = abs(m_pSprite->m_PosY - obj->m_pSprite->m_PosY);
	if (dy > dr) {
		return(false);
	}

	return(true);
}


/* ----------------------------------------- */
/* --- CheckGraze() */
/**
* IuWFNĝ蔻
* ̓苗Ƃ̂苗Ŕ
*
* @return Ȃ\ true s false
*
*/
bool ShootingObject::CheckGraze(ShootingObject* obj)
{
	float  dx, dy, dr;
	bool quick;

	/* --- LȃIuWFNgłȂI */
	if (m_bGrazeEnable == false) {
		return(false);
	}
	if (obj->m_bGrazeEnable == false) {
		return(false);
	}

	quick = true;
	dr = m_fGrazeR + obj->m_fGrazeR;
	dx = m_pSprite->m_PosX - obj->m_pSprite->m_PosX;
	dy = m_pSprite->m_PosY - obj->m_pSprite->m_PosY;
	/* --- ȈՔ肻1 */
	if (dx < 0) {
		dx *= (-1.0);
		if (dx > dr) {
			quick = false;
		}
	}
	else {
		if (dx > dr) {
			quick = false;
		}
	}
	/* - x ̊J傫AƏI */
	if (quick == false) {
		return(false);
	}
	/* --- ȈՔ肻2 */
	if (dy < 0) {
		dy *= (-1.0);
		if (dy > dr) {
			quick = false;
		}
	}
	else {
		if (dy > dr) {
			quick = false;
		}
	}
	/* - y ̊J傫AƏI */
	if (quick == false) {
		return(false);
	}
	/* --- ʂɉ~̋Ŕ */
	dx *= dx;
	dy *= dy;
	dr *= dr;
	dx += dy;
	if (dr < dx) {
		return(false);
	}

	return(true);
}

/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

